/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         hlsl_parse
#define yylex           hlsl_lex
#define yyerror         hlsl_error
#define yydebug         hlsl_debug
#define yynerrs         hlsl_nerrs
#define yylval          hlsl_lval
#define yychar          hlsl_char
#define yylloc          hlsl_lloc

/* First part of user prologue.  */
#line 21 "hlsl.y"

#include "wine/debug.h"

#include <stdio.h>

#include "d3dcompiler_private.h"

WINE_DEFAULT_DEBUG_CHANNEL(hlsl_parser);

int hlsl_lex(void);

struct hlsl_parse_ctx hlsl_ctx;

struct YYLTYPE;
static struct source_location get_location(const struct YYLTYPE *l);

void WINAPIV hlsl_message(const char *fmt, ...)
{
    __ms_va_list args;

    __ms_va_start(args, fmt);
    compilation_message(&hlsl_ctx.messages, fmt, args);
    __ms_va_end(args);
}

static const char *hlsl_get_error_level_name(enum hlsl_error_level level)
{
    static const char * const names[] =
    {
        "error",
        "warning",
        "note",
    };
    return names[level];
}

void WINAPIV hlsl_report_message(const struct source_location loc,
        enum hlsl_error_level level, const char *fmt, ...)
{
    __ms_va_list args;
    char *string = NULL;
    int rc, size = 0;

    while (1)
    {
        __ms_va_start(args, fmt);
        rc = vsnprintf(string, size, fmt, args);
        __ms_va_end(args);

        if (rc >= 0 && rc < size)
            break;

        if (rc >= size)
            size = rc + 1;
        else
            size = size ? size * 2 : 32;

        if (!string)
            string = d3dcompiler_alloc(size);
        else
            string = d3dcompiler_realloc(string, size);
        if (!string)
        {
            ERR("Error reallocating memory for a string.\n");
            return;
        }
    }

    hlsl_message("%s:%u:%u: %s: %s\n", loc.file, loc.line, loc.col,
            hlsl_get_error_level_name(level), string);
    d3dcompiler_free(string);

    if (level == HLSL_LEVEL_ERROR)
        set_parse_status(&hlsl_ctx.status, PARSE_ERR);
    else if (level == HLSL_LEVEL_WARNING)
        set_parse_status(&hlsl_ctx.status, PARSE_WARN);
}

static void hlsl_error(const char *s)
{
    const struct source_location loc =
    {
        .file = hlsl_ctx.source_file,
        .line = hlsl_ctx.line_no,
        .col = hlsl_ctx.column,
    };
    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "%s", s);
}

static void debug_dump_decl(struct hlsl_type *type, DWORD modifiers, const char *declname, unsigned int line_no)
{
    TRACE("Line %u: ", line_no);
    if (modifiers)
        TRACE("%s ", debug_modifiers(modifiers));
    TRACE("%s %s;\n", debug_hlsl_type(type), declname);
}

static void check_invalid_matrix_modifiers(DWORD modifiers, struct source_location loc)
{
    if (modifiers & HLSL_MODIFIERS_MAJORITY_MASK)
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                "'row_major' or 'column_major' modifiers are only allowed for matrices");
    }
}

static BOOL declare_variable(struct hlsl_ir_var *decl, BOOL local)
{
    BOOL ret;

    TRACE("Declaring variable %s.\n", decl->name);
    if (decl->data_type->type != HLSL_CLASS_MATRIX)
        check_invalid_matrix_modifiers(decl->modifiers, decl->loc);

    if (local)
    {
        DWORD invalid = decl->modifiers & (HLSL_STORAGE_EXTERN | HLSL_STORAGE_SHARED
                | HLSL_STORAGE_GROUPSHARED | HLSL_STORAGE_UNIFORM);
        if (invalid)
        {
            hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR,
                    "modifier '%s' invalid for local variables", debug_modifiers(invalid));
        }
        if (decl->semantic)
        {
            hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR,
                    "semantics are not allowed on local variables");
            return FALSE;
        }
    }
    else
    {
        if (find_function(decl->name))
        {
            hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR, "redefinition of '%s'", decl->name);
            return FALSE;
        }
    }
    ret = add_declaration(hlsl_ctx.cur_scope, decl, local);
    if (!ret)
    {
        struct hlsl_ir_var *old = get_variable(hlsl_ctx.cur_scope, decl->name);

        hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR, "\"%s\" already declared", decl->name);
        hlsl_report_message(old->loc, HLSL_LEVEL_NOTE, "\"%s\" was previously declared here", old->name);
        return FALSE;
    }
    return TRUE;
}

static DWORD add_modifiers(DWORD modifiers, DWORD mod, const struct source_location loc)
{
    if (modifiers & mod)
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifier '%s' already specified", debug_modifiers(mod));
        return modifiers;
    }
    if ((mod & HLSL_MODIFIERS_MAJORITY_MASK) && (modifiers & HLSL_MODIFIERS_MAJORITY_MASK))
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR, "more than one matrix majority keyword");
        return modifiers;
    }
    return modifiers | mod;
}

static BOOL add_type_to_scope(struct hlsl_scope *scope, struct hlsl_type *def)
{
    if (get_type(scope, def->name, FALSE))
        return FALSE;

    wine_rb_put(&scope->types, def->name, &def->scope_entry);
    return TRUE;
}

static void declare_predefined_types(struct hlsl_scope *scope)
{
    struct hlsl_type *type;
    unsigned int x, y, bt;
    static const char * const names[] =
    {
        "float",
        "half",
        "double",
        "int",
        "uint",
        "bool",
    };
    char name[10];

    for (bt = 0; bt <= HLSL_TYPE_LAST_SCALAR; ++bt)
    {
        for (y = 1; y <= 4; ++y)
        {
            for (x = 1; x <= 4; ++x)
            {
                sprintf(name, "%s%ux%u", names[bt], x, y);
                type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_MATRIX, bt, x, y);
                add_type_to_scope(scope, type);

                if (y == 1)
                {
                    sprintf(name, "%s%u", names[bt], x);
                    type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_VECTOR, bt, x, y);
                    add_type_to_scope(scope, type);

                    if (x == 1)
                    {
                        sprintf(name, "%s", names[bt]);
                        type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_SCALAR, bt, x, y);
                        add_type_to_scope(scope, type);
                    }
                }
            }
        }
    }

    /* DX8 effects predefined types */
    type = new_hlsl_type(d3dcompiler_strdup("DWORD"), HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("FLOAT"), HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VECTOR"), HLSL_CLASS_VECTOR, HLSL_TYPE_FLOAT, 4, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("MATRIX"), HLSL_CLASS_MATRIX, HLSL_TYPE_FLOAT, 4, 4);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("STRING"), HLSL_CLASS_OBJECT, HLSL_TYPE_STRING, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("TEXTURE"), HLSL_CLASS_OBJECT, HLSL_TYPE_TEXTURE, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("PIXELSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_PIXELSHADER, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VERTEXSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_VERTEXSHADER, 1, 1);
    add_type_to_scope(scope, type);
}

static BOOL append_conditional_break(struct list *cond_list)
{
    struct hlsl_ir_node *condition, *not;
    struct hlsl_ir_jump *jump;
    struct hlsl_ir_if *iff;

    /* E.g. "for (i = 0; ; ++i)". */
    if (!list_count(cond_list))
        return TRUE;

    condition = node_from_list(cond_list);
    if (!(not = new_unary_expr(HLSL_IR_UNOP_LOGIC_NOT, condition, condition->loc)))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    list_add_tail(cond_list, &not->entry);

    if (!(iff = d3dcompiler_alloc(sizeof(*iff))))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    iff->node.type = HLSL_IR_IF;
    iff->condition = not;
    list_add_tail(cond_list, &iff->node.entry);

    if (!(iff->then_instrs = d3dcompiler_alloc(sizeof(*iff->then_instrs))))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    list_init(iff->then_instrs);

    if (!(jump = d3dcompiler_alloc(sizeof(*jump))))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    jump->node.type = HLSL_IR_JUMP;
    jump->type = HLSL_IR_JUMP_BREAK;
    list_add_head(iff->then_instrs, &jump->node.entry);
    return TRUE;
}

enum loop_type
{
    LOOP_FOR,
    LOOP_WHILE,
    LOOP_DO_WHILE
};

static struct list *create_loop(enum loop_type type, struct list *init, struct list *cond,
        struct list *iter, struct list *body, struct source_location loc)
{
    struct list *list = NULL;
    struct hlsl_ir_loop *loop = NULL;
    struct hlsl_ir_if *cond_jump = NULL;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
        goto oom;
    list_init(list);

    if (init)
        list_move_head(list, init);

    loop = d3dcompiler_alloc(sizeof(*loop));
    if (!loop)
        goto oom;
    loop->node.type = HLSL_IR_LOOP;
    loop->node.loc = loc;
    list_add_tail(list, &loop->node.entry);
    loop->body = d3dcompiler_alloc(sizeof(*loop->body));
    if (!loop->body)
        goto oom;
    list_init(loop->body);

    if (!append_conditional_break(cond))
        goto oom;

    if (type != LOOP_DO_WHILE)
        list_move_tail(loop->body, cond);

    list_move_tail(loop->body, body);

    if (iter)
        list_move_tail(loop->body, iter);

    if (type == LOOP_DO_WHILE)
        list_move_tail(loop->body, cond);

    d3dcompiler_free(init);
    d3dcompiler_free(cond);
    d3dcompiler_free(body);
    return list;

oom:
    ERR("Out of memory.\n");
    if (loop)
        d3dcompiler_free(loop->body);
    d3dcompiler_free(loop);
    d3dcompiler_free(cond_jump);
    d3dcompiler_free(list);
    free_instr_list(init);
    free_instr_list(cond);
    free_instr_list(iter);
    free_instr_list(body);
    return NULL;
}

static unsigned int initializer_size(const struct parse_initializer *initializer)
{
    unsigned int count = 0, i;

    for (i = 0; i < initializer->args_count; ++i)
    {
        count += components_count_type(initializer->args[i]->data_type);
    }
    TRACE("Initializer size = %u.\n", count);
    return count;
}

static void free_parse_initializer(struct parse_initializer *initializer)
{
    free_instr_list(initializer->instrs);
    d3dcompiler_free(initializer->args);
}

static struct hlsl_ir_swizzle *new_swizzle(DWORD s, unsigned int components,
        struct hlsl_ir_node *val, struct source_location *loc)
{
    struct hlsl_ir_swizzle *swizzle = d3dcompiler_alloc(sizeof(*swizzle));

    if (!swizzle)
        return NULL;
    swizzle->node.type = HLSL_IR_SWIZZLE;
    swizzle->node.loc = *loc;
    swizzle->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, val->data_type->base_type, components, 1);
    swizzle->val = val;
    swizzle->swizzle = s;
    return swizzle;
}

static struct hlsl_ir_swizzle *get_swizzle(struct hlsl_ir_node *value, const char *swizzle,
        struct source_location *loc)
{
    unsigned int len = strlen(swizzle), component = 0;
    unsigned int i, set, swiz = 0;
    BOOL valid;

    if (value->data_type->type == HLSL_CLASS_MATRIX)
    {
        /* Matrix swizzle */
        BOOL m_swizzle;
        unsigned int inc, x, y;

        if (len < 3 || swizzle[0] != '_')
            return NULL;
        m_swizzle = swizzle[1] == 'm';
        inc = m_swizzle ? 4 : 3;

        if (len % inc || len > inc * 4)
            return NULL;

        for (i = 0; i < len; i += inc)
        {
            if (swizzle[i] != '_')
                return NULL;
            if (m_swizzle)
            {
                if (swizzle[i + 1] != 'm')
                    return NULL;
                x = swizzle[i + 2] - '0';
                y = swizzle[i + 3] - '0';
            }
            else
            {
                x = swizzle[i + 1] - '1';
                y = swizzle[i + 2] - '1';
            }

            if (x >= value->data_type->dimx || y >= value->data_type->dimy)
                return NULL;
            swiz |= (y << 4 | x) << component * 8;
            component++;
        }
        return new_swizzle(swiz, component, value, loc);
    }

    /* Vector swizzle */
    if (len > 4)
        return NULL;

    for (set = 0; set < 2; ++set)
    {
        valid = TRUE;
        component = 0;
        for (i = 0; i < len; ++i)
        {
            char c[2][4] = {{'x', 'y', 'z', 'w'}, {'r', 'g', 'b', 'a'}};
            unsigned int s = 0;

            for (s = 0; s < 4; ++s)
            {
                if (swizzle[i] == c[set][s])
                    break;
            }
            if (s == 4)
            {
                valid = FALSE;
                break;
            }

            if (s >= value->data_type->dimx)
                return NULL;
            swiz |= s << component * 2;
            component++;
        }
        if (valid)
            return new_swizzle(swiz, component, value, loc);
    }

    return NULL;
}

static struct hlsl_ir_jump *new_return(struct hlsl_ir_node *value, struct source_location loc)
{
    struct hlsl_type *return_type = hlsl_ctx.cur_function->return_type;
    struct hlsl_ir_jump *jump = d3dcompiler_alloc(sizeof(*jump));
    if (!jump)
    {
        ERR("Out of memory\n");
        return NULL;
    }
    jump->node.type = HLSL_IR_JUMP;
    jump->node.loc = loc;
    jump->type = HLSL_IR_JUMP_RETURN;
    if (value)
    {
        if (!(jump->return_value = implicit_conversion(value, return_type, &loc)))
        {
            d3dcompiler_free(jump);
            return NULL;
        }
    }
    else if (return_type->base_type != HLSL_TYPE_VOID)
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR, "non-void function must return a value");
        d3dcompiler_free(jump);
        return NULL;
    }

    return jump;
}

static void struct_var_initializer(struct list *list, struct hlsl_ir_var *var,
        struct parse_initializer *initializer)
{
    struct hlsl_type *type = var->data_type;
    struct hlsl_struct_field *field;
    struct hlsl_ir_node *assignment;
    struct hlsl_ir_deref *deref;
    unsigned int i = 0;

    if (initializer_size(initializer) != components_count_type(type))
    {
        hlsl_report_message(var->loc, HLSL_LEVEL_ERROR, "structure initializer mismatch");
        free_parse_initializer(initializer);
        return;
    }

    list_move_tail(list, initializer->instrs);
    d3dcompiler_free(initializer->instrs);

    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
    {
        struct hlsl_ir_node *node = initializer->args[i];

        if (i++ >= initializer->args_count)
        {
            d3dcompiler_free(initializer->args);
            return;
        }
        if (components_count_type(field->type) == components_count_type(node->data_type))
        {
            deref = new_record_deref(&new_var_deref(var)->node, field);
            if (!deref)
            {
                ERR("Out of memory.\n");
                break;
            }
            deref->node.loc = node->loc;
            list_add_tail(list, &deref->node.entry);
            assignment = make_assignment(&deref->node, ASSIGN_OP_ASSIGN, node);
            list_add_tail(list, &assignment->entry);
        }
        else
            FIXME("Initializing with \"mismatched\" fields is not supported yet.\n");
    }

    d3dcompiler_free(initializer->args);
}

static void free_parse_variable_def(struct parse_variable_def *v)
{
    free_parse_initializer(&v->initializer);
    d3dcompiler_free(v->name);
    d3dcompiler_free((void *)v->semantic);
    d3dcompiler_free(v->reg_reservation);
    d3dcompiler_free(v);
}

static struct list *declare_vars(struct hlsl_type *basic_type, DWORD modifiers, struct list *var_list)
{
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;
    struct hlsl_ir_var *var;
    struct hlsl_ir_node *assignment;
    BOOL ret, local = TRUE;
    struct list *statements_list = d3dcompiler_alloc(sizeof(*statements_list));

    if (!statements_list)
    {
        ERR("Out of memory.\n");
        LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
            free_parse_variable_def(v);
        d3dcompiler_free(var_list);
        return NULL;
    }
    list_init(statements_list);

    if (!var_list)
        return statements_list;

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
    {
        var = d3dcompiler_alloc(sizeof(*var));
        if (!var)
        {
            ERR("Out of memory.\n");
            free_parse_variable_def(v);
            continue;
        }
        if (v->array_size)
            type = new_array_type(basic_type, v->array_size);
        else
            type = basic_type;
        var->data_type = type;
        var->loc = v->loc;
        var->name = v->name;
        var->modifiers = modifiers;
        var->semantic = v->semantic;
        var->reg_reservation = v->reg_reservation;
        debug_dump_decl(type, modifiers, v->name, v->loc.line);

        if (hlsl_ctx.cur_scope == hlsl_ctx.globals)
        {
            var->modifiers |= HLSL_STORAGE_UNIFORM;
            local = FALSE;
        }

        if (type->modifiers & HLSL_MODIFIER_CONST && !(var->modifiers & HLSL_STORAGE_UNIFORM) && !v->initializer.args_count)
        {
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR, "const variable without initializer");
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }

        ret = declare_variable(var, local);
        if (!ret)
        {
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }
        TRACE("Declared variable %s.\n", var->name);

        if (v->initializer.args_count)
        {
            unsigned int size = initializer_size(&v->initializer);
            struct hlsl_ir_deref *deref;

            TRACE("Variable with initializer.\n");
            if (type->type <= HLSL_CLASS_LAST_NUMERIC
                    && type->dimx * type->dimy != size && size != 1)
            {
                if (size < type->dimx * type->dimy)
                {
                    hlsl_report_message(v->loc, HLSL_LEVEL_ERROR,
                            "'%s' initializer does not match", v->name);
                    free_parse_initializer(&v->initializer);
                    d3dcompiler_free(v);
                    continue;
                }
            }
            if ((type->type == HLSL_CLASS_STRUCT || type->type == HLSL_CLASS_ARRAY)
                    && components_count_type(type) != size)
            {
                hlsl_report_message(v->loc, HLSL_LEVEL_ERROR,
                        "'%s' initializer does not match", v->name);
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }

            if (type->type == HLSL_CLASS_STRUCT)
            {
                struct_var_initializer(statements_list, var, &v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (type->type > HLSL_CLASS_LAST_NUMERIC)
            {
                FIXME("Initializers for non scalar/struct variables not supported yet.\n");
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (v->array_size > 0)
            {
                FIXME("Initializing arrays is not supported yet.\n");
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (v->initializer.args_count > 1)
            {
                FIXME("Complex initializers are not supported yet.\n");
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }

            list_move_tail(statements_list, v->initializer.instrs);
            d3dcompiler_free(v->initializer.instrs);

            deref = new_var_deref(var);
            list_add_tail(statements_list, &deref->node.entry);
            assignment = make_assignment(&deref->node, ASSIGN_OP_ASSIGN, v->initializer.args[0]);
            d3dcompiler_free(v->initializer.args);
            list_add_tail(statements_list, &assignment->entry);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(var_list);
    return statements_list;
}

static BOOL add_struct_field(struct list *fields, struct hlsl_struct_field *field)
{
    struct hlsl_struct_field *f;

    LIST_FOR_EACH_ENTRY(f, fields, struct hlsl_struct_field, entry)
    {
        if (!strcmp(f->name, field->name))
            return FALSE;
    }
    list_add_tail(fields, &field->entry);
    return TRUE;
}

static struct hlsl_type *apply_type_modifiers(struct hlsl_type *type, DWORD *modifiers, struct source_location loc)
{
    struct hlsl_type *new_type;

    if (!(*modifiers & HLSL_TYPE_MODIFIERS_MASK))
        return type;

    if (!(new_type = clone_hlsl_type(type)))
        return NULL;

    new_type->modifiers = add_modifiers(new_type->modifiers, *modifiers, loc);
    *modifiers &= ~HLSL_TYPE_MODIFIERS_MASK;
    return new_type;
}

static struct list *gen_struct_fields(struct hlsl_type *type, DWORD modifiers, struct list *fields)
{
    struct parse_variable_def *v, *v_next;
    struct hlsl_struct_field *field;
    struct list *list;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    list_init(list);
    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, fields, struct parse_variable_def, entry)
    {
        debug_dump_decl(type, 0, v->name, v->loc.line);
        field = d3dcompiler_alloc(sizeof(*field));
        if (!field)
        {
            ERR("Out of memory.\n");
            d3dcompiler_free(v);
            return list;
        }
        field->type = type;
        field->name = v->name;
        field->modifiers = modifiers;
        field->semantic = v->semantic;
        if (v->initializer.args_count)
        {
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR, "struct field with an initializer.\n");
            free_parse_initializer(&v->initializer);
        }
        list_add_tail(list, &field->entry);
        d3dcompiler_free(v);
    }
    d3dcompiler_free(fields);
    return list;
}

static struct hlsl_type *new_struct_type(const char *name, struct list *fields)
{
    struct hlsl_type *type = d3dcompiler_alloc(sizeof(*type));

    if (!type)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    type->type = HLSL_CLASS_STRUCT;
    type->name = name;
    type->dimx = type->dimy = 1;
    type->e.elements = fields;

    list_add_tail(&hlsl_ctx.types, &type->entry);

    return type;
}

static BOOL add_typedef(DWORD modifiers, struct hlsl_type *orig_type, struct list *list)
{
    BOOL ret;
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, list, struct parse_variable_def, entry)
    {
        if (v->array_size)
            type = new_array_type(orig_type, v->array_size);
        else
            type = clone_hlsl_type(orig_type);
        if (!type)
        {
            ERR("Out of memory\n");
            return FALSE;
        }
        d3dcompiler_free((void *)type->name);
        type->name = v->name;
        type->modifiers |= modifiers;

        if (type->type != HLSL_CLASS_MATRIX)
            check_invalid_matrix_modifiers(type->modifiers, v->loc);

        ret = add_type_to_scope(hlsl_ctx.cur_scope, type);
        if (!ret)
        {
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR,
                    "redefinition of custom type '%s'", v->name);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(list);
    return TRUE;
}

static BOOL add_func_parameter(struct list *list, struct parse_parameter *param, const struct source_location loc)
{
    struct hlsl_ir_var *decl = d3dcompiler_alloc(sizeof(*decl));

    if (!decl)
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    decl->data_type = param->type;
    decl->loc = loc;
    decl->name = param->name;
    decl->semantic = param->semantic;
    decl->reg_reservation = param->reg_reservation;
    decl->modifiers = param->modifiers;

    if (!add_declaration(hlsl_ctx.cur_scope, decl, FALSE))
    {
        free_declaration(decl);
        return FALSE;
    }
    list_add_tail(list, &decl->param_entry);
    return TRUE;
}

static struct reg_reservation *parse_reg_reservation(const char *reg_string)
{
    struct reg_reservation *reg_res;
    enum bwritershader_param_register_type type;
    DWORD regnum = 0;

    switch (reg_string[0])
    {
        case 'c':
            type = BWRITERSPR_CONST;
            break;
        case 'i':
            type = BWRITERSPR_CONSTINT;
            break;
        case 'b':
            type = BWRITERSPR_CONSTBOOL;
            break;
        case 's':
            type = BWRITERSPR_SAMPLER;
            break;
        default:
            FIXME("Unsupported register type.\n");
            return NULL;
     }

    if (!sscanf(reg_string + 1, "%u", &regnum))
    {
        FIXME("Unsupported register reservation syntax.\n");
        return NULL;
    }

    reg_res = d3dcompiler_alloc(sizeof(*reg_res));
    if (!reg_res)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    reg_res->type = type;
    reg_res->regnum = regnum;
    return reg_res;
}

static const struct hlsl_ir_function_decl *get_overloaded_func(struct wine_rb_tree *funcs, char *name,
        struct list *params, BOOL exact_signature)
{
    struct hlsl_ir_function *func;
    struct wine_rb_entry *entry;

    entry = wine_rb_get(funcs, name);
    if (entry)
    {
        func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);

        entry = wine_rb_get(&func->overloads, params);
        if (!entry)
        {
            if (!exact_signature)
                FIXME("No exact match, search for a compatible overloaded function (if any).\n");
            return NULL;
        }
        return WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function_decl, entry);
    }
    return NULL;
}

static struct list *append_unop(struct list *list, struct hlsl_ir_node *node)
{
    list_add_tail(list, &node->entry);
    return list;
}

static struct list *append_binop(struct list *first, struct list *second, struct hlsl_ir_node *node)
{
    list_move_tail(first, second);
    d3dcompiler_free(second);
    list_add_tail(first, &node->entry);
    return first;
}

static struct list *make_list(struct hlsl_ir_node *node)
{
    struct list *list;

    if (!(list = d3dcompiler_alloc(sizeof(*list))))
    {
        ERR("Out of memory.\n");
        free_instr(node);
        return NULL;
    }
    list_init(list);
    list_add_tail(list, &node->entry);
    return list;
}

static unsigned int evaluate_array_dimension(struct hlsl_ir_node *node)
{
    if (node->data_type->type != HLSL_CLASS_SCALAR)
        return 0;

    switch (node->type)
    {
    case HLSL_IR_CONSTANT:
    {
        struct hlsl_ir_constant *constant = constant_from_node(node);

        switch (constant->node.data_type->base_type)
        {
        case HLSL_TYPE_UINT:
            return constant->v.value.u[0];
        case HLSL_TYPE_INT:
            return constant->v.value.i[0];
        case HLSL_TYPE_FLOAT:
            return constant->v.value.f[0];
        case HLSL_TYPE_DOUBLE:
            return constant->v.value.d[0];
        case HLSL_TYPE_BOOL:
            return constant->v.value.b[0];
        default:
            WARN("Invalid type %s.\n", debug_base_type(constant->node.data_type));
            return 0;
        }
    }
    case HLSL_IR_CONSTRUCTOR:
    case HLSL_IR_DEREF:
    case HLSL_IR_EXPR:
    case HLSL_IR_SWIZZLE:
        FIXME("Unhandled type %s.\n", debug_node_type(node->type));
        return 0;
    case HLSL_IR_ASSIGNMENT:
    default:
        WARN("Invalid node type %s.\n", debug_node_type(node->type));
        return 0;
    }
}


#line 1047 "hlsl.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int hlsl_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    KW_BLENDSTATE = 258,
    KW_BREAK = 259,
    KW_BUFFER = 260,
    KW_CBUFFER = 261,
    KW_COLUMN_MAJOR = 262,
    KW_COMPILE = 263,
    KW_CONST = 264,
    KW_CONTINUE = 265,
    KW_DEPTHSTENCILSTATE = 266,
    KW_DEPTHSTENCILVIEW = 267,
    KW_DISCARD = 268,
    KW_DO = 269,
    KW_DOUBLE = 270,
    KW_ELSE = 271,
    KW_EXTERN = 272,
    KW_FALSE = 273,
    KW_FOR = 274,
    KW_GEOMETRYSHADER = 275,
    KW_GROUPSHARED = 276,
    KW_IF = 277,
    KW_IN = 278,
    KW_INLINE = 279,
    KW_INOUT = 280,
    KW_MATRIX = 281,
    KW_NAMESPACE = 282,
    KW_NOINTERPOLATION = 283,
    KW_OUT = 284,
    KW_PASS = 285,
    KW_PIXELSHADER = 286,
    KW_PRECISE = 287,
    KW_RASTERIZERSTATE = 288,
    KW_RENDERTARGETVIEW = 289,
    KW_RETURN = 290,
    KW_REGISTER = 291,
    KW_ROW_MAJOR = 292,
    KW_SAMPLER = 293,
    KW_SAMPLER1D = 294,
    KW_SAMPLER2D = 295,
    KW_SAMPLER3D = 296,
    KW_SAMPLERCUBE = 297,
    KW_SAMPLER_STATE = 298,
    KW_SAMPLERCOMPARISONSTATE = 299,
    KW_SHARED = 300,
    KW_STATEBLOCK = 301,
    KW_STATEBLOCK_STATE = 302,
    KW_STATIC = 303,
    KW_STRING = 304,
    KW_STRUCT = 305,
    KW_SWITCH = 306,
    KW_TBUFFER = 307,
    KW_TECHNIQUE = 308,
    KW_TECHNIQUE10 = 309,
    KW_TEXTURE = 310,
    KW_TEXTURE1D = 311,
    KW_TEXTURE1DARRAY = 312,
    KW_TEXTURE2D = 313,
    KW_TEXTURE2DARRAY = 314,
    KW_TEXTURE2DMS = 315,
    KW_TEXTURE2DMSARRAY = 316,
    KW_TEXTURE3D = 317,
    KW_TEXTURE3DARRAY = 318,
    KW_TEXTURECUBE = 319,
    KW_TRUE = 320,
    KW_TYPEDEF = 321,
    KW_UNIFORM = 322,
    KW_VECTOR = 323,
    KW_VERTEXSHADER = 324,
    KW_VOID = 325,
    KW_VOLATILE = 326,
    KW_WHILE = 327,
    OP_INC = 328,
    OP_DEC = 329,
    OP_AND = 330,
    OP_OR = 331,
    OP_EQ = 332,
    OP_LEFTSHIFT = 333,
    OP_LEFTSHIFTASSIGN = 334,
    OP_RIGHTSHIFT = 335,
    OP_RIGHTSHIFTASSIGN = 336,
    OP_ELLIPSIS = 337,
    OP_LE = 338,
    OP_GE = 339,
    OP_NE = 340,
    OP_ADDASSIGN = 341,
    OP_SUBASSIGN = 342,
    OP_MULASSIGN = 343,
    OP_DIVASSIGN = 344,
    OP_MODASSIGN = 345,
    OP_ANDASSIGN = 346,
    OP_ORASSIGN = 347,
    OP_XORASSIGN = 348,
    OP_UNKNOWN1 = 349,
    OP_UNKNOWN2 = 350,
    OP_UNKNOWN3 = 351,
    OP_UNKNOWN4 = 352,
    PRE_LINE = 353,
    VAR_IDENTIFIER = 354,
    TYPE_IDENTIFIER = 355,
    NEW_IDENTIFIER = 356,
    STRING = 357,
    C_FLOAT = 358,
    C_INTEGER = 359
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 995 "hlsl.y"

    struct hlsl_type *type;
    INT intval;
    FLOAT floatval;
    BOOL boolval;
    char *name;
    DWORD modifiers;
    struct hlsl_ir_node *instr;
    struct list *list;
    struct parse_function function;
    struct parse_parameter parameter;
    struct parse_initializer initializer;
    struct parse_variable_def *variable_def;
    struct parse_if_body if_body;
    enum parse_unary_op unary_op;
    enum parse_assign_op assign_op;
    struct reg_reservation *reg_reservation;
    struct parse_colon_attribute colon_attribute;

#line 1221 "hlsl.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE hlsl_lval;
extern YYLTYPE hlsl_lloc;
int hlsl_parse (void);





#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   871

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  66
/* YYNRULES -- Number of rules.  */
#define YYNRULES  177
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  319

#define YYUNDEFTOK  2
#define YYMAXUTOK   359


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   120,     2,     2,     2,   124,   125,     2,
     108,   109,   122,   118,   111,   119,   117,   123,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   110,   105,
     112,   114,   113,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   115,     2,   116,   126,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   106,   127,   107,   121,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1181,  1181,  1183,  1217,  1221,  1224,  1229,  1251,  1275,
    1276,  1278,  1301,  1307,  1308,  1309,  1312,  1316,  1335,  1336,
    1338,  1348,  1355,  1363,  1400,  1405,  1412,  1416,  1417,  1420,
    1424,  1429,  1435,  1441,  1446,  1455,  1460,  1465,  1476,  1487,
    1504,  1507,  1518,  1522,  1526,  1531,  1535,  1554,  1574,  1578,
    1583,  1588,  1593,  1598,  1603,  1611,  1629,  1630,  1631,  1642,
    1643,  1645,  1661,  1667,  1673,  1681,  1692,  1695,  1700,  1706,
    1712,  1721,  1734,  1737,  1761,  1764,  1768,  1772,  1776,  1780,
    1784,  1788,  1792,  1796,  1800,  1804,  1809,  1817,  1821,  1826,
    1831,  1839,  1849,  1853,  1858,  1862,  1869,  1870,  1871,  1872,
    1873,  1874,  1876,  1885,  1895,  1917,  1922,  1928,  1932,  1936,
    1941,  1950,  1955,  1960,  1975,  1990,  2005,  2026,  2031,  2035,
    2052,  2069,  2124,  2179,  2217,  2221,  2233,  2245,  2260,  2288,
    2292,  2296,  2300,  2305,  2309,  2314,  2319,  2325,  2329,  2334,
    2340,  2344,  2348,  2353,  2357,  2362,  2367,  2372,  2378,  2382,
    2387,  2393,  2397,  2402,  2406,  2411,  2415,  2420,  2424,  2429,
    2433,  2438,  2442,  2447,  2451,  2466,  2470,  2474,  2478,  2482,
    2486,  2490,  2494,  2498,  2502,  2506,  2511,  2515
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "KW_BLENDSTATE", "KW_BREAK", "KW_BUFFER",
  "KW_CBUFFER", "KW_COLUMN_MAJOR", "KW_COMPILE", "KW_CONST", "KW_CONTINUE",
  "KW_DEPTHSTENCILSTATE", "KW_DEPTHSTENCILVIEW", "KW_DISCARD", "KW_DO",
  "KW_DOUBLE", "KW_ELSE", "KW_EXTERN", "KW_FALSE", "KW_FOR",
  "KW_GEOMETRYSHADER", "KW_GROUPSHARED", "KW_IF", "KW_IN", "KW_INLINE",
  "KW_INOUT", "KW_MATRIX", "KW_NAMESPACE", "KW_NOINTERPOLATION", "KW_OUT",
  "KW_PASS", "KW_PIXELSHADER", "KW_PRECISE", "KW_RASTERIZERSTATE",
  "KW_RENDERTARGETVIEW", "KW_RETURN", "KW_REGISTER", "KW_ROW_MAJOR",
  "KW_SAMPLER", "KW_SAMPLER1D", "KW_SAMPLER2D", "KW_SAMPLER3D",
  "KW_SAMPLERCUBE", "KW_SAMPLER_STATE", "KW_SAMPLERCOMPARISONSTATE",
  "KW_SHARED", "KW_STATEBLOCK", "KW_STATEBLOCK_STATE", "KW_STATIC",
  "KW_STRING", "KW_STRUCT", "KW_SWITCH", "KW_TBUFFER", "KW_TECHNIQUE",
  "KW_TECHNIQUE10", "KW_TEXTURE", "KW_TEXTURE1D", "KW_TEXTURE1DARRAY",
  "KW_TEXTURE2D", "KW_TEXTURE2DARRAY", "KW_TEXTURE2DMS",
  "KW_TEXTURE2DMSARRAY", "KW_TEXTURE3D", "KW_TEXTURE3DARRAY",
  "KW_TEXTURECUBE", "KW_TRUE", "KW_TYPEDEF", "KW_UNIFORM", "KW_VECTOR",
  "KW_VERTEXSHADER", "KW_VOID", "KW_VOLATILE", "KW_WHILE", "OP_INC",
  "OP_DEC", "OP_AND", "OP_OR", "OP_EQ", "OP_LEFTSHIFT",
  "OP_LEFTSHIFTASSIGN", "OP_RIGHTSHIFT", "OP_RIGHTSHIFTASSIGN",
  "OP_ELLIPSIS", "OP_LE", "OP_GE", "OP_NE", "OP_ADDASSIGN", "OP_SUBASSIGN",
  "OP_MULASSIGN", "OP_DIVASSIGN", "OP_MODASSIGN", "OP_ANDASSIGN",
  "OP_ORASSIGN", "OP_XORASSIGN", "OP_UNKNOWN1", "OP_UNKNOWN2",
  "OP_UNKNOWN3", "OP_UNKNOWN4", "PRE_LINE", "VAR_IDENTIFIER",
  "TYPE_IDENTIFIER", "NEW_IDENTIFIER", "STRING", "C_FLOAT", "C_INTEGER",
  "';'", "'{'", "'}'", "'('", "')'", "':'", "','", "'<'", "'>'", "'='",
  "'['", "']'", "'.'", "'+'", "'-'", "'!'", "'~'", "'*'", "'/'", "'%'",
  "'&'", "'^'", "'|'", "'?'", "$accept", "hlsl_prog", "preproc_directive",
  "struct_declaration", "struct_spec", "named_struct_spec",
  "unnamed_struct_spec", "any_identifier", "fields_list", "field_type",
  "field", "func_declaration", "func_prototype", "compound_statement",
  "scope_start", "var_identifier", "colon_attribute", "semantic",
  "register_opt", "parameters", "param_list", "parameter", "input_mods",
  "input_mod", "type", "base_type", "declaration_statement",
  "typedef_type", "typedef", "type_specs", "type_spec", "declaration",
  "variables_def_optional", "variables_def", "variable_def", "array",
  "var_modifiers", "complex_initializer", "initializer_expr",
  "initializer_expr_list", "boolean", "statement_list", "statement",
  "jump_statement", "selection_statement", "if_body", "loop_statement",
  "expr_statement", "primary_expr", "postfix_expr", "unary_expr",
  "unary_op", "mul_expr", "add_expr", "shift_expr", "relational_expr",
  "equality_expr", "bitand_expr", "bitxor_expr", "bitor_expr",
  "logicand_expr", "logicor_expr", "conditional_expr", "assignment_expr",
  "assign_op", "expr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    59,   123,   125,    40,    41,
      58,    44,    60,    62,    61,    91,    93,    46,    43,    45,
      33,   126,    42,    47,    37,    38,    94,   124,    63
};
# endif

#define YYPACT_NINF (-240)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-36)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -240,   707,  -240,   799,   799,   799,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   -74,  -240,  -240,  -240,  -240,
     -41,  -240,  -240,  -240,   135,  -240,  -240,  -240,  -240,  -240,
    -240,  -240,  -240,  -240,   135,  -240,  -240,  -240,  -240,   -88,
    -240,   -57,  -240,  -240,  -240,  -240,  -240,    93,   -22,  -240,
    -240,   -69,  -240,  -240,    97,  -240,  -240,  -240,   -69,  -240,
     316,    -2,  -240,   -28,  -240,  -240,   -23,    -2,  -240,   -20,
      17,    27,  -240,    -5,    22,    57,   -61,   -20,   -60,  -240,
     316,  -240,    64,    96,   395,  -240,   100,   646,   646,  -240,
    -240,  -240,  -240,   646,  -240,  -240,  -240,  -240,  -240,  -240,
     135,  -240,   208,  -240,  -240,  -240,  -240,  -240,  -240,   -21,
      23,   646,    78,    71,    61,    16,   -43,     9,    94,    59,
     148,   -55,  -240,  -240,   -29,   128,   127,    26,  -240,   143,
     646,   145,  -240,   -69,  -240,  -240,  -240,  -240,   -69,   185,
    -240,   646,  -240,   250,   -25,   646,  -240,  -240,   250,    -3,
      19,  -240,  -240,  -240,  -240,   646,   -69,  -240,  -240,  -240,
    -240,  -240,  -240,  -240,  -240,  -240,  -240,  -240,   646,  -240,
     646,   646,   646,   646,   646,   646,   646,   646,   646,   646,
     646,   646,   646,   646,   646,   646,   646,   646,   646,  -240,
     646,  -240,   160,  -240,  -240,   328,   751,   161,   -70,   -12,
     152,  -240,  -240,  -240,   158,   159,  -240,   162,   456,    60,
     169,  -240,    73,   -59,  -240,   646,   -49,  -240,  -240,  -240,
    -240,  -240,  -240,    78,    78,    71,    71,    61,    61,    61,
      61,    16,    16,   -43,     9,    94,    59,   148,    68,  -240,
     167,    25,  -240,   -69,  -240,  -240,   156,  -240,   175,  -240,
     517,   173,  -240,   800,   145,   646,   456,   250,   456,   316,
     316,   176,  -240,   105,  -240,  -240,   646,   182,    31,  -240,
     -69,   646,  -240,  -240,  -240,  -240,  -240,  -240,  -240,   250,
    -240,   130,   646,   646,   271,  -240,  -240,   646,  -240,   646,
    -240,   180,  -240,   133,    10,  -240,   -69,   189,   137,   138,
     316,  -240,  -240,  -240,  -240,   -69,  -240,   585,   145,  -240,
     316,   316,  -240,   186,  -240,  -240,  -240,  -240,  -240
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    74,     1,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,     0,     6,     5,    57,     3,
       0,     4,    58,    56,     0,    85,    83,    75,    79,    76,
      77,    84,    78,    80,     0,    81,    82,     7,    22,    26,
      21,     0,    49,    50,    51,    52,    53,     0,     0,    48,
      54,    66,     9,    10,     0,    45,    60,    59,     0,    24,
      74,     0,    13,    55,    15,    16,     0,     0,    14,    72,
       0,    67,    68,    13,    15,     0,     0,    72,     0,    62,
      74,    93,     0,     0,    74,    92,     0,    74,    74,   116,
     113,   114,   111,    74,   129,   130,   131,   132,    98,    96,
       0,   115,    74,    94,    99,   100,   101,    97,   118,   124,
     133,    74,   137,   140,   143,   148,   151,   153,   155,   157,
     159,   161,   163,   176,     0,     0,     0,    74,    16,     0,
      74,    29,     8,     0,    26,    65,    64,    61,     0,     0,
      26,    74,   103,     0,     0,    74,   125,   126,     0,     0,
       0,    25,    95,   119,   120,    74,     0,   171,   172,   166,
     167,   168,   169,   170,   173,   174,   175,   165,    74,   127,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,   112,
      74,    55,     0,    12,    17,     0,    74,     0,     0,     0,
      70,    30,    31,    69,    40,     0,    63,     0,    74,     0,
       0,   102,     0,    72,   117,    74,     0,   121,   164,   134,
     135,   136,   133,   138,   139,   141,   142,   146,   147,   144,
     145,   149,   150,   152,   154,   156,   158,   160,     0,   177,
       0,     0,    19,     0,    18,    11,     0,    73,     0,    32,
      74,    36,    37,    74,    29,    74,    74,     0,    74,    74,
      74,     0,    90,     0,    89,   122,    74,     0,     0,    46,
       0,    74,    71,    86,    40,    42,    44,    43,    41,     0,
      23,     0,    74,    74,   105,   104,   107,    74,   123,    74,
     162,     0,    20,     0,     0,    38,     0,     0,     0,     0,
      74,   128,    91,    47,    33,     0,    87,    74,    29,   108,
      74,    74,   106,     0,    88,    39,   110,   109,    34
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -240,  -240,  -240,  -240,   262,  -240,   102,   -33,   170,  -240,
    -240,  -240,  -240,   281,    28,  -240,  -239,  -240,  -240,  -240,
    -240,    29,  -240,  -240,    -8,   103,   301,  -240,  -240,  -240,
     166,    98,  -240,   -34,   172,   -50,    -1,  -240,  -232,    37,
    -240,  -240,   -79,  -240,  -240,  -240,  -240,  -186,  -240,  -240,
     -27,  -240,    77,    58,    33,    80,   134,   140,   136,   146,
     132,  -240,  -240,   -83,  -240,   -64
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    17,    18,    51,    52,    53,    69,   127,   243,
     194,    19,    20,    98,    60,    75,   200,   201,   202,   205,
     251,   252,   253,   278,   150,    55,    99,    58,    22,    78,
      79,    23,    70,    76,    72,   131,   143,   272,   262,   263,
     101,   102,   103,   104,   105,   285,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   168,   124
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      24,   139,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    66,   280,    54,    71,   273,    59,
     144,   187,   258,   152,   248,    77,    57,   136,    37,   149,
      62,    68,    64,     3,   181,     4,    42,    43,    44,    45,
      46,   190,   182,     5,   135,   137,   247,     6,   125,   215,
     133,   138,   153,   154,     7,    61,   130,   302,     8,   100,
     146,   147,   190,     9,    38,    39,   198,   265,    49,   315,
     282,    10,   283,   188,    11,   302,   189,   209,   -14,   100,
     211,   212,   190,   128,   169,   218,   190,    62,    68,    64,
      67,   216,   148,    13,   155,   130,   156,    14,    50,   177,
     178,   100,   157,   -27,   158,    77,   214,   239,   190,   159,
     160,   161,   162,   163,   164,   165,   166,   306,    62,    68,
      64,   307,   132,   217,   238,   191,   195,   215,   179,   180,
     -28,    65,   264,   193,   183,   210,   292,   167,   133,   175,
     213,   176,   133,   219,   220,   221,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,    41,   204,   261,   126,   134,   249,   264,   208,   259,
     129,   190,   140,    42,    43,    44,    45,    46,   266,   190,
     284,   286,   260,   290,   190,    47,   185,   244,   264,   173,
     174,   281,    62,    63,    64,   195,    73,    68,    74,    65,
     170,   171,   172,    48,   141,    49,   264,   257,   145,   268,
     227,   228,   229,   230,   288,     3,   289,     4,   298,   299,
     184,   312,    80,   186,   264,     5,    81,    82,   191,     6,
      83,   316,   317,   225,   226,    50,     7,   293,   192,   297,
       8,   190,   304,    84,   305,     9,   310,   311,   190,   190,
     223,   224,   279,    10,   197,   199,    11,   207,   100,   100,
     301,   231,   232,   308,   240,   246,   250,   -35,   254,   269,
     255,   296,   313,    85,    12,    13,    41,   215,   267,    14,
      86,    87,    88,   270,   274,   287,   291,   300,    42,    43,
      44,    45,    46,   303,   309,   318,    56,   242,   196,   100,
     125,    40,    21,   295,   206,   203,   256,    89,   294,   100,
     100,    90,    91,    92,    39,   151,    93,   233,    48,   237,
      49,   235,     0,     3,   234,     4,    94,    95,    96,    97,
      80,     0,   236,     5,    81,    82,     0,     6,    83,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     8,     0,
      50,    84,     0,     9,    41,     0,     0,     0,     0,     0,
       0,    10,     0,     0,    11,     0,    42,    43,    44,    45,
      46,     0,     0,     0,     0,     0,     0,     0,   241,     0,
       0,    85,    12,    13,     0,     0,     0,    14,    86,    87,
      88,     0,     0,     0,     0,     0,    48,     0,    49,     0,
       0,     0,     3,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     5,    81,     0,    89,     6,     0,     0,    90,
      91,    92,    39,     7,    93,     0,     0,     8,    50,     0,
       0,     0,     9,     0,    94,    95,    96,    97,     0,     0,
      10,     0,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      85,     0,    13,     3,     0,     4,    14,     0,    87,    88,
       0,     0,     0,     5,    81,     0,     0,     6,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     8,     0,
       0,     0,     0,     9,    89,     0,     0,     0,    90,    91,
     142,    10,     0,    93,    11,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    95,    96,    97,     0,     0,     0,
       0,    85,     0,    13,     3,     0,     4,    14,     0,    87,
      88,     0,     0,     0,     5,    81,     0,     0,     6,     0,
       0,     0,     0,     0,     0,     7,     0,     0,     0,     8,
       0,     0,     0,     0,     9,    89,     0,     0,     0,    90,
      91,    92,    10,     0,    93,    11,     0,     0,     0,     0,
       0,     0,     0,     0,    94,    95,    96,    97,     0,     0,
       0,     0,    85,     0,    13,     0,     0,     0,    14,     0,
      87,    88,     3,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     5,    81,     0,     0,     6,     0,     0,     0,
       0,     0,     0,     7,     0,     0,    89,     8,     0,     0,
      90,    91,     9,   271,     0,    93,     0,     0,     0,     0,
      10,     0,     0,    11,     0,    94,    95,    96,    97,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      85,     0,    13,     3,     0,     4,    14,     0,    87,    88,
       0,     0,     0,     5,    81,     0,     0,     6,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     8,     0,
       0,     0,     0,     9,    89,     0,     0,     0,    90,    91,
       0,    10,   314,    93,    11,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    95,    96,    97,     2,     0,     0,
       0,    85,     0,    13,     3,     0,     4,    14,     0,    87,
      88,     0,     0,     0,     5,     0,     0,     0,     6,     0,
       0,     0,     0,     0,     0,     7,     0,     0,     0,     8,
       0,     0,     0,     0,     9,    89,     0,     0,     0,    90,
      91,     0,    10,     0,    93,    11,     0,     0,     3,     0,
       4,     0,     0,     0,    94,    95,    96,    97,     5,     0,
       0,     0,     6,    12,    13,     0,     0,     0,    14,     7,
       0,     0,     0,     8,     0,     0,     0,     0,     9,     0,
       0,     0,     0,     0,     0,     0,    10,     0,     0,    11,
       0,     0,     0,     0,     0,    15,     3,     3,     4,     4,
       0,     0,    16,     0,     0,     0,     5,     5,    13,     0,
       6,     6,    14,   275,     0,   276,     0,     7,     7,   277,
       0,     8,     8,     0,     0,     0,     9,     9,     0,     0,
       0,     0,     0,     0,    10,    10,     0,    11,    11,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   245,     0,
       0,     0,     0,     0,     0,     0,    13,    13,     0,     0,
      14,    14
};

static const yytype_int16 yycheck[] =
{
       1,    80,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    47,   254,    24,    51,   250,   107,
      84,    76,   208,   102,    36,    58,    34,    77,   102,    93,
      99,   100,   101,     7,    77,     9,    38,    39,    40,    41,
      42,   111,    85,    17,   105,   105,   116,    21,    50,   108,
     111,   111,    73,    74,    28,   112,   115,   289,    32,    60,
      87,    88,   111,    37,   105,   106,   130,   116,    70,   308,
     256,    45,   258,   128,    48,   307,   105,   141,   106,    80,
     105,   145,   111,   106,   111,   168,   111,    99,   100,   101,
     112,   155,    93,    67,   115,   115,   117,    71,   100,    83,
      84,   102,    79,   108,    81,   138,   109,   190,   111,    86,
      87,    88,    89,    90,    91,    92,    93,   107,    99,   100,
     101,   111,   105,   156,   188,   100,   127,   108,   112,   113,
     108,   106,   215,   107,   125,   143,   105,   114,   111,    78,
     148,    80,   111,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    26,   134,   213,    61,   108,   199,   250,   140,   109,
      67,   111,   108,    38,    39,    40,    41,    42,   110,   111,
     259,   260,   109,   266,   111,    50,   127,   195,   271,   118,
     119,   255,    99,   100,   101,   196,    99,   100,   101,   106,
     122,   123,   124,    68,   108,    70,   289,   208,   108,   243,
     177,   178,   179,   180,   109,     7,   111,     9,   282,   283,
     126,   300,    14,    75,   307,    17,    18,    19,   100,    21,
      22,   310,   311,   175,   176,   100,    28,   270,   111,   109,
      32,   111,   109,    35,   111,    37,   109,   109,   111,   111,
     173,   174,   253,    45,   111,   110,    48,    72,   259,   260,
     287,   181,   182,   296,   104,   104,   114,   109,   109,   113,
     108,   279,   305,    65,    66,    67,    26,   108,   111,    71,
      72,    73,    74,   108,   111,   109,   104,    16,    38,    39,
      40,    41,    42,   113,   105,   109,    34,   195,   128,   300,
      50,    20,     1,   274,   138,   133,   208,    99,   271,   310,
     311,   103,   104,   105,   106,   107,   108,   183,    68,   187,
      70,   185,    -1,     7,   184,     9,   118,   119,   120,   121,
      14,    -1,   186,    17,    18,    19,    -1,    21,    22,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,
     100,    35,    -1,    37,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    48,    -1,    38,    39,    40,    41,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    65,    66,    67,    -1,    -1,    -1,    71,    72,    73,
      74,    -1,    -1,    -1,    -1,    -1,    68,    -1,    70,    -1,
      -1,    -1,     7,    -1,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    -1,    99,    21,    -1,    -1,   103,
     104,   105,   106,    28,   108,    -1,    -1,    32,   100,    -1,
      -1,    -1,    37,    -1,   118,   119,   120,   121,    -1,    -1,
      45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,     7,    -1,     9,    71,    -1,    73,    74,
      -1,    -1,    -1,    17,    18,    -1,    -1,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,   104,
     105,    45,    -1,   108,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    65,    -1,    67,     7,    -1,     9,    71,    -1,    73,
      74,    -1,    -1,    -1,    17,    18,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,
     104,   105,    45,    -1,   108,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   118,   119,   120,   121,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    -1,    -1,    71,    -1,
      73,    74,     7,    -1,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    -1,    -1,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    99,    32,    -1,    -1,
     103,   104,    37,   106,    -1,   108,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    48,    -1,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,     7,    -1,     9,    71,    -1,    73,    74,
      -1,    -1,    -1,    17,    18,    -1,    -1,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,   104,
      -1,    45,   107,   108,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,   119,   120,   121,     0,    -1,    -1,
      -1,    65,    -1,    67,     7,    -1,     9,    71,    -1,    73,
      74,    -1,    -1,    -1,    17,    -1,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,
     104,    -1,    45,    -1,   108,    48,    -1,    -1,     7,    -1,
       9,    -1,    -1,    -1,   118,   119,   120,   121,    17,    -1,
      -1,    -1,    21,    66,    67,    -1,    -1,    -1,    71,    28,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    98,     7,     7,     9,     9,
      -1,    -1,   105,    -1,    -1,    -1,    17,    17,    67,    -1,
      21,    21,    71,    23,    -1,    25,    -1,    28,    28,    29,
      -1,    32,    32,    -1,    -1,    -1,    37,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    45,    -1,    48,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   107,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    67,    -1,    -1,
      71,    71
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   130,     0,     7,     9,    17,    21,    28,    32,    37,
      45,    48,    66,    67,    71,    98,   105,   131,   132,   140,
     141,   155,   157,   160,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   102,   105,   106,
     142,    26,    38,    39,    40,    41,    42,    50,    68,    70,
     100,   133,   134,   135,   153,   154,   133,   153,   156,   107,
     143,   112,    99,   100,   101,   106,   136,   112,   100,   136,
     161,   162,   163,    99,   101,   144,   162,   136,   158,   159,
      14,    18,    19,    22,    35,    65,    72,    73,    74,    99,
     103,   104,   105,   108,   118,   119,   120,   121,   142,   155,
     165,   169,   170,   171,   172,   173,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   194,    50,   154,   137,   106,   154,
     115,   164,   105,   111,   108,   105,   164,   105,   111,   171,
     108,   108,   105,   165,   194,   108,   179,   179,   165,   194,
     153,   107,   171,    73,    74,   115,   117,    79,    81,    86,
      87,    88,    89,    90,    91,    92,    93,   114,   193,   179,
     122,   123,   124,   118,   119,    78,    80,    83,    84,   112,
     113,    77,    85,   125,   126,   127,    75,    76,   128,   105,
     111,   100,   111,   107,   139,   165,   137,   111,   194,   110,
     145,   146,   147,   163,   143,   148,   159,    72,   143,   194,
     153,   105,   194,   153,   109,   108,   194,   136,   192,   179,
     179,   179,   179,   181,   181,   182,   182,   183,   183,   183,
     183,   184,   184,   185,   186,   187,   188,   189,   194,   192,
     104,    50,   135,   138,   153,   107,   104,   116,    36,   136,
     114,   149,   150,   151,   109,   108,   160,   165,   176,   109,
     109,   164,   167,   168,   192,   116,   110,   111,   162,   113,
     108,   106,   166,   167,   111,    23,    25,    29,   152,   165,
     145,   194,   176,   176,   171,   174,   171,   109,   109,   111,
     192,   104,   105,   136,   168,   150,   153,   109,   194,   194,
      16,   179,   167,   113,   109,   111,   107,   111,   136,   105,
     109,   109,   171,   136,   107,   145,   171,   171,   109
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   129,   130,   130,   130,   130,   130,   131,   132,   133,
     133,   134,   135,   136,   136,   136,   137,   137,   138,   138,
     139,   140,   140,   141,   142,   142,   143,   144,   144,   145,
     145,   145,   146,   147,   147,   148,   148,   149,   149,   150,
     151,   151,   152,   152,   152,   153,   153,   153,   154,   154,
     154,   154,   154,   154,   154,   154,   155,   155,   155,   156,
     156,   157,   158,   158,   159,   160,   161,   161,   162,   162,
     163,   163,   164,   164,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   166,   166,   166,   167,
     168,   168,   169,   169,   170,   170,   171,   171,   171,   171,
     171,   171,   172,   172,   173,   174,   174,   175,   175,   175,
     175,   176,   176,   177,   177,   177,   177,   177,   178,   178,
     178,   178,   178,   178,   179,   179,   179,   179,   179,   180,
     180,   180,   180,   181,   181,   181,   181,   182,   182,   182,
     183,   183,   183,   184,   184,   184,   184,   184,   185,   185,
     185,   186,   186,   187,   187,   188,   188,   189,   189,   190,
     190,   191,   191,   192,   192,   193,   193,   193,   193,   193,
     193,   193,   193,   193,   193,   193,   194,   194
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     4,     1,
       1,     5,     4,     1,     1,     1,     0,     2,     1,     1,
       4,     2,     2,     7,     2,     4,     0,     1,     1,     0,
       1,     1,     2,     5,     7,     1,     2,     1,     3,     5,
       0,     2,     1,     1,     1,     1,     6,     8,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     5,     1,     3,     2,     4,     0,     1,     1,     3,
       3,     5,     0,     3,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     1,
       1,     3,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     2,     5,     1,     3,     5,     7,     8,
       8,     1,     2,     1,     1,     1,     1,     3,     1,     2,
       2,     3,     4,     5,     1,     2,     2,     2,     6,     1,
       1,     1,     1,     1,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     5,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 1181 "hlsl.y"
                            {
                            }
#line 2889 "hlsl.tab.c"
    break;

  case 3:
#line 1184 "hlsl.y"
                            {
                                const struct hlsl_ir_function_decl *decl;

                                decl = get_overloaded_func(&hlsl_ctx.functions, (yyvsp[0].function).name, (yyvsp[0].function).decl->parameters, TRUE);
                                if (decl && !decl->func->intrinsic)
                                {
                                    if (decl->body && (yyvsp[0].function).decl->body)
                                    {
                                        hlsl_report_message((yyvsp[0].function).decl->loc, HLSL_LEVEL_ERROR,
                                                "redefinition of function %s", debugstr_a((yyvsp[0].function).name));
                                        YYABORT;
                                    }
                                    else if (!compare_hlsl_types(decl->return_type, (yyvsp[0].function).decl->return_type))
                                    {
                                        hlsl_report_message((yyvsp[0].function).decl->loc, HLSL_LEVEL_ERROR,
                                                "redefining function %s with a different return type",
                                                debugstr_a((yyvsp[0].function).name));
                                        hlsl_report_message(decl->loc, HLSL_LEVEL_NOTE,
                                                "%s previously declared here",
                                                debugstr_a((yyvsp[0].function).name));
                                        YYABORT;
                                    }
                                }

                                if ((yyvsp[0].function).decl->return_type->base_type == HLSL_TYPE_VOID && (yyvsp[0].function).decl->semantic)
                                {
                                    hlsl_report_message((yyvsp[0].function).decl->loc, HLSL_LEVEL_ERROR,
                                            "void function with a semantic");
                                }

                                TRACE("Adding function '%s' to the function list.\n", (yyvsp[0].function).name);
                                add_function_decl(&hlsl_ctx.functions, (yyvsp[0].function).name, (yyvsp[0].function).decl, FALSE);
                            }
#line 2927 "hlsl.tab.c"
    break;

  case 4:
#line 1218 "hlsl.y"
                            {
                                TRACE("Declaration statement parsed.\n");
                            }
#line 2935 "hlsl.tab.c"
    break;

  case 5:
#line 1222 "hlsl.y"
                            {
                            }
#line 2942 "hlsl.tab.c"
    break;

  case 6:
#line 1225 "hlsl.y"
                            {
                                TRACE("Skipping stray semicolon.\n");
                            }
#line 2950 "hlsl.tab.c"
    break;

  case 7:
#line 1230 "hlsl.y"
                            {
                                const char **new_array = NULL;

                                TRACE("Updating line information to file %s, line %u\n", debugstr_a((yyvsp[0].name)), (yyvsp[-1].intval));
                                hlsl_ctx.line_no = (yyvsp[-1].intval);
                                if (strcmp((yyvsp[0].name), hlsl_ctx.source_file))
                                    new_array = d3dcompiler_realloc(hlsl_ctx.source_files,
                                            sizeof(*hlsl_ctx.source_files) * (hlsl_ctx.source_files_count + 1));

                                if (new_array)
                                {
                                    hlsl_ctx.source_files = new_array;
                                    hlsl_ctx.source_files[hlsl_ctx.source_files_count++] = (yyvsp[0].name);
                                    hlsl_ctx.source_file = (yyvsp[0].name);
                                }
                                else
                                {
                                    d3dcompiler_free((yyvsp[0].name));
                                }
                            }
#line 2975 "hlsl.tab.c"
    break;

  case 8:
#line 1252 "hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(yyvsp[-1].list))
                                {
                                    if (!(yyvsp[-2].type)->name)
                                    {
                                        hlsl_report_message(get_location(&(yylsp[-2])), HLSL_LEVEL_ERROR,
                                                "anonymous struct declaration with no variables");
                                    }
                                    if (modifiers)
                                    {
                                        hlsl_report_message(get_location(&(yylsp[-3])), HLSL_LEVEL_ERROR,
                                                "modifier not allowed on struct type declaration");
                                    }
                                }

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;
                                (yyval.list) = declare_vars(type, modifiers, (yyvsp[-1].list));
                            }
#line 3002 "hlsl.tab.c"
    break;

  case 11:
#line 1279 "hlsl.y"
                            {
                                BOOL ret;

                                TRACE("Structure %s declaration.\n", debugstr_a((yyvsp[-3].name)));
                                (yyval.type) = new_struct_type((yyvsp[-3].name), (yyvsp[-1].list));

                                if (get_variable(hlsl_ctx.cur_scope, (yyvsp[-3].name)))
                                {
                                    hlsl_report_message(get_location(&(yylsp[-3])),
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'", (yyvsp[-3].name));
                                    YYABORT;
                                }

                                ret = add_type_to_scope(hlsl_ctx.cur_scope, (yyval.type));
                                if (!ret)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-3])),
                                            HLSL_LEVEL_ERROR, "redefinition of struct '%s'", (yyvsp[-3].name));
                                    YYABORT;
                                }
                            }
#line 3028 "hlsl.tab.c"
    break;

  case 12:
#line 1302 "hlsl.y"
                            {
                                TRACE("Anonymous structure declaration.\n");
                                (yyval.type) = new_struct_type(NULL, (yyvsp[-1].list));
                            }
#line 3037 "hlsl.tab.c"
    break;

  case 16:
#line 1312 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3046 "hlsl.tab.c"
    break;

  case 17:
#line 1317 "hlsl.y"
                            {
                                BOOL ret;
                                struct hlsl_struct_field *field, *next;

                                (yyval.list) = (yyvsp[-1].list);
                                LIST_FOR_EACH_ENTRY_SAFE(field, next, (yyvsp[0].list), struct hlsl_struct_field, entry)
                                {
                                    ret = add_struct_field((yyval.list), field);
                                    if (ret == FALSE)
                                    {
                                        hlsl_report_message(get_location(&(yylsp[0])),
                                                HLSL_LEVEL_ERROR, "redefinition of '%s'", field->name);
                                        d3dcompiler_free(field);
                                    }
                                }
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 3068 "hlsl.tab.c"
    break;

  case 20:
#line 1339 "hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;
                                (yyval.list) = gen_struct_fields(type, modifiers, (yyvsp[-1].list));
                            }
#line 3081 "hlsl.tab.c"
    break;

  case 21:
#line 1349 "hlsl.y"
                            {
                                TRACE("Function %s parsed.\n", (yyvsp[-1].function).name);
                                (yyval.function) = (yyvsp[-1].function);
                                (yyval.function).decl->body = (yyvsp[0].list);
                                pop_scope(&hlsl_ctx);
                            }
#line 3092 "hlsl.tab.c"
    break;

  case 22:
#line 1356 "hlsl.y"
                            {
                                TRACE("Function prototype for %s.\n", (yyvsp[-1].function).name);
                                (yyval.function) = (yyvsp[-1].function);
                                pop_scope(&hlsl_ctx);
                            }
#line 3102 "hlsl.tab.c"
    break;

  case 23:
#line 1364 "hlsl.y"
                            {
                                if ((yyvsp[-6].modifiers))
                                {
                                    hlsl_report_message(get_location(&(yylsp[-6])), HLSL_LEVEL_ERROR,
                                            "unexpected modifiers on a function");
                                    YYABORT;
                                }
                                if (get_variable(hlsl_ctx.globals, (yyvsp[-4].name)))
                                {
                                    hlsl_report_message(get_location(&(yylsp[-4])),
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'\n", (yyvsp[-4].name));
                                    YYABORT;
                                }
                                if ((yyvsp[-5].type)->base_type == HLSL_TYPE_VOID && (yyvsp[0].colon_attribute).semantic)
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])),
                                            HLSL_LEVEL_ERROR, "void function with a semantic");
                                }

                                if ((yyvsp[0].colon_attribute).reg_reservation)
                                {
                                    FIXME("Unexpected register reservation for a function.\n");
                                    d3dcompiler_free((yyvsp[0].colon_attribute).reg_reservation);
                                }
                                (yyval.function).decl = new_func_decl((yyvsp[-5].type), (yyvsp[-2].list));
                                if (!(yyval.function).decl)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                (yyval.function).name = (yyvsp[-4].name);
                                (yyval.function).decl->semantic = (yyvsp[0].colon_attribute).semantic;
                                (yyval.function).decl->loc = get_location(&(yylsp[-4]));
                                hlsl_ctx.cur_function = (yyval.function).decl;
                            }
#line 3142 "hlsl.tab.c"
    break;

  case 24:
#line 1401 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3151 "hlsl.tab.c"
    break;

  case 25:
#line 1406 "hlsl.y"
                            {
                                pop_scope(&hlsl_ctx);
                                (yyval.list) = (yyvsp[-1].list);
                            }
#line 3160 "hlsl.tab.c"
    break;

  case 26:
#line 1412 "hlsl.y"
                            {
                                push_scope(&hlsl_ctx);
                            }
#line 3168 "hlsl.tab.c"
    break;

  case 29:
#line 1420 "hlsl.y"
                            {
                                (yyval.colon_attribute).semantic = NULL;
                                (yyval.colon_attribute).reg_reservation = NULL;
                            }
#line 3177 "hlsl.tab.c"
    break;

  case 30:
#line 1425 "hlsl.y"
                            {
                                (yyval.colon_attribute).semantic = (yyvsp[0].name);
                                (yyval.colon_attribute).reg_reservation = NULL;
                            }
#line 3186 "hlsl.tab.c"
    break;

  case 31:
#line 1430 "hlsl.y"
                            {
                                (yyval.colon_attribute).semantic = NULL;
                                (yyval.colon_attribute).reg_reservation = (yyvsp[0].reg_reservation);
                            }
#line 3195 "hlsl.tab.c"
    break;

  case 32:
#line 1436 "hlsl.y"
                            {
                                (yyval.name) = (yyvsp[0].name);
                            }
#line 3203 "hlsl.tab.c"
    break;

  case 33:
#line 1442 "hlsl.y"
                            {
                                (yyval.reg_reservation) = parse_reg_reservation((yyvsp[-1].name));
                                d3dcompiler_free((yyvsp[-1].name));
                            }
#line 3212 "hlsl.tab.c"
    break;

  case 34:
#line 1447 "hlsl.y"
                            {
                                FIXME("Ignoring shader target %s in a register reservation.\n", debugstr_a((yyvsp[-3].name)));
                                d3dcompiler_free((yyvsp[-3].name));

                                (yyval.reg_reservation) = parse_reg_reservation((yyvsp[-1].name));
                                d3dcompiler_free((yyvsp[-1].name));
                            }
#line 3224 "hlsl.tab.c"
    break;

  case 35:
#line 1456 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3233 "hlsl.tab.c"
    break;

  case 36:
#line 1461 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 3241 "hlsl.tab.c"
    break;

  case 37:
#line 1466 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                if (!add_func_parameter((yyval.list), &(yyvsp[0].parameter), get_location(&(yylsp[0]))))
                                {
                                    ERR("Error adding function parameter %s.\n", (yyvsp[0].parameter).name);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                            }
#line 3256 "hlsl.tab.c"
    break;

  case 38:
#line 1477 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                if (!add_func_parameter((yyval.list), &(yyvsp[0].parameter), get_location(&(yylsp[0]))))
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])), HLSL_LEVEL_ERROR,
                                            "duplicate parameter %s", (yyvsp[0].parameter).name);
                                    YYABORT;
                                }
                            }
#line 3270 "hlsl.tab.c"
    break;

  case 39:
#line 1488 "hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;

                                (yyval.parameter).modifiers = (yyvsp[-4].modifiers) ? (yyvsp[-4].modifiers) : HLSL_STORAGE_IN;
                                (yyval.parameter).modifiers |= modifiers;
                                (yyval.parameter).type = type;
                                (yyval.parameter).name = (yyvsp[-1].name);
                                (yyval.parameter).semantic = (yyvsp[0].colon_attribute).semantic;
                                (yyval.parameter).reg_reservation = (yyvsp[0].colon_attribute).reg_reservation;
                            }
#line 3289 "hlsl.tab.c"
    break;

  case 40:
#line 1504 "hlsl.y"
                            {
                                (yyval.modifiers) = 0;
                            }
#line 3297 "hlsl.tab.c"
    break;

  case 41:
#line 1508 "hlsl.y"
                            {
                                if ((yyvsp[-1].modifiers) & (yyvsp[0].modifiers))
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])), HLSL_LEVEL_ERROR,
                                            "duplicate input-output modifiers");
                                    YYABORT;
                                }
                                (yyval.modifiers) = (yyvsp[-1].modifiers) | (yyvsp[0].modifiers);
                            }
#line 3311 "hlsl.tab.c"
    break;

  case 42:
#line 1519 "hlsl.y"
                            {
                                (yyval.modifiers) = HLSL_STORAGE_IN;
                            }
#line 3319 "hlsl.tab.c"
    break;

  case 43:
#line 1523 "hlsl.y"
                            {
                                (yyval.modifiers) = HLSL_STORAGE_OUT;
                            }
#line 3327 "hlsl.tab.c"
    break;

  case 44:
#line 1527 "hlsl.y"
                            {
                                (yyval.modifiers) = HLSL_STORAGE_IN | HLSL_STORAGE_OUT;
                            }
#line 3335 "hlsl.tab.c"
    break;

  case 45:
#line 1532 "hlsl.y"
                            {
                                (yyval.type) = (yyvsp[0].type);
                            }
#line 3343 "hlsl.tab.c"
    break;

  case 46:
#line 1536 "hlsl.y"
                            {
                                if ((yyvsp[-3].type)->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_message("Line %u: vectors of non-scalar types are not allowed.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                                if ((yyvsp[-1].intval) < 1 || (yyvsp[-1].intval) > 4)
                                {
                                    hlsl_message("Line %u: vector size must be between 1 and 4.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }

                                (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, (yyvsp[-3].type)->base_type, (yyvsp[-1].intval), 1);
                            }
#line 3366 "hlsl.tab.c"
    break;

  case 47:
#line 1555 "hlsl.y"
                            {
                                if ((yyvsp[-5].type)->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_message("Line %u: matrices of non-scalar types are not allowed.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                                if ((yyvsp[-3].intval) < 1 || (yyvsp[-3].intval) > 4 || (yyvsp[-1].intval) < 1 || (yyvsp[-1].intval) > 4)
                                {
                                    hlsl_message("Line %u: matrix dimensions must be between 1 and 4.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }

                                (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_MATRIX, (yyvsp[-5].type)->base_type, (yyvsp[-3].intval), (yyvsp[-1].intval));
                            }
#line 3389 "hlsl.tab.c"
    break;

  case 48:
#line 1575 "hlsl.y"
                            {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("void"), HLSL_CLASS_OBJECT, HLSL_TYPE_VOID, 1, 1);
                            }
#line 3397 "hlsl.tab.c"
    break;

  case 49:
#line 1579 "hlsl.y"
                            {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_GENERIC;
                            }
#line 3406 "hlsl.tab.c"
    break;

  case 50:
#line 1584 "hlsl.y"
                            {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler1D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_1D;
                            }
#line 3415 "hlsl.tab.c"
    break;

  case 51:
#line 1589 "hlsl.y"
                            {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler2D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_2D;
                            }
#line 3424 "hlsl.tab.c"
    break;

  case 52:
#line 1594 "hlsl.y"
                            {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler3D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_3D;
                            }
#line 3433 "hlsl.tab.c"
    break;

  case 53:
#line 1599 "hlsl.y"
                            {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("samplerCUBE"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_CUBE;
                            }
#line 3442 "hlsl.tab.c"
    break;

  case 54:
#line 1604 "hlsl.y"
                            {
                                struct hlsl_type *type;

                                type = get_type(hlsl_ctx.cur_scope, (yyvsp[0].name), TRUE);
                                (yyval.type) = type;
                                d3dcompiler_free((yyvsp[0].name));
                            }
#line 3454 "hlsl.tab.c"
    break;

  case 55:
#line 1612 "hlsl.y"
                            {
                                struct hlsl_type *type;

                                type = get_type(hlsl_ctx.cur_scope, (yyvsp[0].name), TRUE);
                                if (type->type != HLSL_CLASS_STRUCT)
                                {
                                    hlsl_message("Line %u: redefining %s as a structure.\n",
                                            hlsl_ctx.line_no, (yyvsp[0].name));
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                }
                                else
                                {
                                    (yyval.type) = type;
                                }
                                d3dcompiler_free((yyvsp[0].name));
                            }
#line 3475 "hlsl.tab.c"
    break;

  case 58:
#line 1632 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                if (!(yyval.list))
                                {
                                    ERR("Out of memory\n");
                                    YYABORT;
                                }
                                list_init((yyval.list));
                            }
#line 3489 "hlsl.tab.c"
    break;

  case 61:
#line 1646 "hlsl.y"
                            {
                                if ((yyvsp[-3].modifiers) & ~HLSL_TYPE_MODIFIERS_MASK)
                                {
                                    struct parse_variable_def *v, *v_next;
                                    hlsl_report_message(get_location(&(yylsp[-4])),
                                            HLSL_LEVEL_ERROR, "modifier not allowed on typedefs");
                                    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, (yyvsp[-1].list), struct parse_variable_def, entry)
                                        d3dcompiler_free(v);
                                    d3dcompiler_free((yyvsp[-1].list));
                                    YYABORT;
                                }
                                if (!add_typedef((yyvsp[-3].modifiers), (yyvsp[-2].type), (yyvsp[-1].list)))
                                    YYABORT;
                            }
#line 3508 "hlsl.tab.c"
    break;

  case 62:
#line 1662 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 3518 "hlsl.tab.c"
    break;

  case 63:
#line 1668 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                list_add_tail((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 3527 "hlsl.tab.c"
    break;

  case 64:
#line 1674 "hlsl.y"
                            {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                (yyval.variable_def)->loc = get_location(&(yylsp[-1]));
                                (yyval.variable_def)->name = (yyvsp[-1].name);
                                (yyval.variable_def)->array_size = (yyvsp[0].intval);
                            }
#line 3538 "hlsl.tab.c"
    break;

  case 65:
#line 1682 "hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;
                                (yyval.list) = declare_vars(type, modifiers, (yyvsp[-1].list));
                            }
#line 3551 "hlsl.tab.c"
    break;

  case 66:
#line 1692 "hlsl.y"
                            {
                                (yyval.list) = NULL;
                            }
#line 3559 "hlsl.tab.c"
    break;

  case 67:
#line 1696 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 3567 "hlsl.tab.c"
    break;

  case 68:
#line 1701 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 3577 "hlsl.tab.c"
    break;

  case 69:
#line 1707 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                list_add_tail((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 3586 "hlsl.tab.c"
    break;

  case 70:
#line 1713 "hlsl.y"
                            {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                (yyval.variable_def)->loc = get_location(&(yylsp[-2]));
                                (yyval.variable_def)->name = (yyvsp[-2].name);
                                (yyval.variable_def)->array_size = (yyvsp[-1].intval);
                                (yyval.variable_def)->semantic = (yyvsp[0].colon_attribute).semantic;
                                (yyval.variable_def)->reg_reservation = (yyvsp[0].colon_attribute).reg_reservation;
                            }
#line 3599 "hlsl.tab.c"
    break;

  case 71:
#line 1722 "hlsl.y"
                            {
                                TRACE("Declaration with initializer.\n");
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                (yyval.variable_def)->loc = get_location(&(yylsp[-4]));
                                (yyval.variable_def)->name = (yyvsp[-4].name);
                                (yyval.variable_def)->array_size = (yyvsp[-3].intval);
                                (yyval.variable_def)->semantic = (yyvsp[-2].colon_attribute).semantic;
                                (yyval.variable_def)->reg_reservation = (yyvsp[-2].colon_attribute).reg_reservation;
                                (yyval.variable_def)->initializer = (yyvsp[0].initializer);
                            }
#line 3614 "hlsl.tab.c"
    break;

  case 72:
#line 1734 "hlsl.y"
                            {
                                (yyval.intval) = 0;
                            }
#line 3622 "hlsl.tab.c"
    break;

  case 73:
#line 1738 "hlsl.y"
                            {
                                unsigned int size = evaluate_array_dimension(node_from_list((yyvsp[-1].list)));

                                free_instr_list((yyvsp[-1].list));

                                if (!size)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                                            "array size is not a positive integer constant\n");
                                    YYABORT;
                                }
                                TRACE("Array size %u.\n", size);

                                if (size > 65536)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                                            "array size must be between 1 and 65536");
                                    YYABORT;
                                }
                                (yyval.intval) = size;
                            }
#line 3648 "hlsl.tab.c"
    break;

  case 74:
#line 1761 "hlsl.y"
                            {
                                (yyval.modifiers) = 0;
                            }
#line 3656 "hlsl.tab.c"
    break;

  case 75:
#line 1765 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_EXTERN, get_location(&(yylsp[-1])));
                            }
#line 3664 "hlsl.tab.c"
    break;

  case 76:
#line 1769 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_NOINTERPOLATION, get_location(&(yylsp[-1])));
                            }
#line 3672 "hlsl.tab.c"
    break;

  case 77:
#line 1773 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_PRECISE, get_location(&(yylsp[-1])));
                            }
#line 3680 "hlsl.tab.c"
    break;

  case 78:
#line 1777 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_SHARED, get_location(&(yylsp[-1])));
                            }
#line 3688 "hlsl.tab.c"
    break;

  case 79:
#line 1781 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_GROUPSHARED, get_location(&(yylsp[-1])));
                            }
#line 3696 "hlsl.tab.c"
    break;

  case 80:
#line 1785 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_STATIC, get_location(&(yylsp[-1])));
                            }
#line 3704 "hlsl.tab.c"
    break;

  case 81:
#line 1789 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_UNIFORM, get_location(&(yylsp[-1])));
                            }
#line 3712 "hlsl.tab.c"
    break;

  case 82:
#line 1793 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_VOLATILE, get_location(&(yylsp[-1])));
                            }
#line 3720 "hlsl.tab.c"
    break;

  case 83:
#line 1797 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_CONST, get_location(&(yylsp[-1])));
                            }
#line 3728 "hlsl.tab.c"
    break;

  case 84:
#line 1801 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_ROW_MAJOR, get_location(&(yylsp[-1])));
                            }
#line 3736 "hlsl.tab.c"
    break;

  case 85:
#line 1805 "hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_COLUMN_MAJOR, get_location(&(yylsp[-1])));
                            }
#line 3744 "hlsl.tab.c"
    break;

  case 86:
#line 1810 "hlsl.y"
                            {
                                (yyval.initializer).args_count = 1;
                                if (!((yyval.initializer).args = d3dcompiler_alloc(sizeof(*(yyval.initializer).args))))
                                    YYABORT;
                                (yyval.initializer).args[0] = node_from_list((yyvsp[0].list));
                                (yyval.initializer).instrs = (yyvsp[0].list);
                            }
#line 3756 "hlsl.tab.c"
    break;

  case 87:
#line 1818 "hlsl.y"
                            {
                                (yyval.initializer) = (yyvsp[-1].initializer);
                            }
#line 3764 "hlsl.tab.c"
    break;

  case 88:
#line 1822 "hlsl.y"
                            {
                                (yyval.initializer) = (yyvsp[-2].initializer);
                            }
#line 3772 "hlsl.tab.c"
    break;

  case 89:
#line 1827 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 3780 "hlsl.tab.c"
    break;

  case 90:
#line 1832 "hlsl.y"
                            {
                                (yyval.initializer).args_count = 1;
                                if (!((yyval.initializer).args = d3dcompiler_alloc(sizeof(*(yyval.initializer).args))))
                                    YYABORT;
                                (yyval.initializer).args[0] = node_from_list((yyvsp[0].list));
                                (yyval.initializer).instrs = (yyvsp[0].list);
                            }
#line 3792 "hlsl.tab.c"
    break;

  case 91:
#line 1840 "hlsl.y"
                            {
                                (yyval.initializer) = (yyvsp[-2].initializer);
                                if (!((yyval.initializer).args = d3dcompiler_realloc((yyval.initializer).args, ((yyval.initializer).args_count + 1) * sizeof(*(yyval.initializer).args))))
                                    YYABORT;
                                (yyval.initializer).args[(yyval.initializer).args_count++] = node_from_list((yyvsp[0].list));
                                list_move_tail((yyval.initializer).instrs, (yyvsp[0].list));
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 3805 "hlsl.tab.c"
    break;

  case 92:
#line 1850 "hlsl.y"
                            {
                                (yyval.boolval) = TRUE;
                            }
#line 3813 "hlsl.tab.c"
    break;

  case 93:
#line 1854 "hlsl.y"
                            {
                                (yyval.boolval) = FALSE;
                            }
#line 3821 "hlsl.tab.c"
    break;

  case 94:
#line 1859 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 3829 "hlsl.tab.c"
    break;

  case 95:
#line 1863 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-1].list);
                                list_move_tail((yyval.list), (yyvsp[0].list));
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 3839 "hlsl.tab.c"
    break;

  case 102:
#line 1877 "hlsl.y"
                            {
                                struct hlsl_ir_jump *jump;
                                if (!(jump = new_return(node_from_list((yyvsp[-1].list)), get_location(&(yylsp[-2])))))
                                    YYABORT;

                                (yyval.list) = (yyvsp[-1].list);
                                list_add_tail((yyval.list), &jump->node.entry);
                            }
#line 3852 "hlsl.tab.c"
    break;

  case 103:
#line 1886 "hlsl.y"
                            {
                                struct hlsl_ir_jump *jump;
                                if (!(jump = new_return(NULL, get_location(&(yylsp[-1])))))
                                    YYABORT;
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_tail((yyval.list), &jump->node.entry);
                            }
#line 3865 "hlsl.tab.c"
    break;

  case 104:
#line 1896 "hlsl.y"
                            {
                                struct hlsl_ir_if *instr = d3dcompiler_alloc(sizeof(*instr));
                                if (!instr)
                                {
                                    ERR("Out of memory\n");
                                    YYABORT;
                                }
                                instr->node.type = HLSL_IR_IF;
                                instr->node.loc = get_location(&(yylsp[-4]));
                                instr->condition = node_from_list((yyvsp[-2].list));
                                instr->then_instrs = (yyvsp[0].if_body).then_instrs;
                                instr->else_instrs = (yyvsp[0].if_body).else_instrs;
                                if (instr->condition->data_type->dimx > 1 || instr->condition->data_type->dimy > 1)
                                {
                                    hlsl_report_message(instr->node.loc, HLSL_LEVEL_ERROR,
                                            "if condition requires a scalar");
                                }
                                (yyval.list) = (yyvsp[-2].list);
                                list_add_tail((yyval.list), &instr->node.entry);
                            }
#line 3890 "hlsl.tab.c"
    break;

  case 105:
#line 1918 "hlsl.y"
                            {
                                (yyval.if_body).then_instrs = (yyvsp[0].list);
                                (yyval.if_body).else_instrs = NULL;
                            }
#line 3899 "hlsl.tab.c"
    break;

  case 106:
#line 1923 "hlsl.y"
                            {
                                (yyval.if_body).then_instrs = (yyvsp[-2].list);
                                (yyval.if_body).else_instrs = (yyvsp[0].list);
                            }
#line 3908 "hlsl.tab.c"
    break;

  case 107:
#line 1929 "hlsl.y"
                            {
                                (yyval.list) = create_loop(LOOP_WHILE, NULL, (yyvsp[-2].list), NULL, (yyvsp[0].list), get_location(&(yylsp[-4])));
                            }
#line 3916 "hlsl.tab.c"
    break;

  case 108:
#line 1933 "hlsl.y"
                            {
                                (yyval.list) = create_loop(LOOP_DO_WHILE, NULL, (yyvsp[-2].list), NULL, (yyvsp[-5].list), get_location(&(yylsp[-6])));
                            }
#line 3924 "hlsl.tab.c"
    break;

  case 109:
#line 1937 "hlsl.y"
                            {
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[-4].list), (yyvsp[-3].list), (yyvsp[-2].list), (yyvsp[0].list), get_location(&(yylsp[-7])));
                                pop_scope(&hlsl_ctx);
                            }
#line 3933 "hlsl.tab.c"
    break;

  case 110:
#line 1942 "hlsl.y"
                            {
                                if (!(yyvsp[-4].list))
                                    hlsl_report_message(get_location(&(yylsp[-4])), HLSL_LEVEL_WARNING,
                                            "no expressions in for loop initializer");
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[-4].list), (yyvsp[-3].list), (yyvsp[-2].list), (yyvsp[0].list), get_location(&(yylsp[-7])));
                                pop_scope(&hlsl_ctx);
                            }
#line 3945 "hlsl.tab.c"
    break;

  case 111:
#line 1951 "hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3954 "hlsl.tab.c"
    break;

  case 112:
#line 1956 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-1].list);
                            }
#line 3962 "hlsl.tab.c"
    break;

  case 113:
#line 1961 "hlsl.y"
                            {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                c->node.loc = get_location(&yylloc);
                                c->node.data_type = new_hlsl_type(d3dcompiler_strdup("float"), HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
                                c->v.value.f[0] = (yyvsp[0].floatval);
                                if (!((yyval.list) = make_list(&c->node)))
                                    YYABORT;
                            }
#line 3981 "hlsl.tab.c"
    break;

  case 114:
#line 1976 "hlsl.y"
                            {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                c->node.loc = get_location(&yylloc);
                                c->node.data_type = new_hlsl_type(d3dcompiler_strdup("int"), HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
                                c->v.value.i[0] = (yyvsp[0].intval);
                                if (!((yyval.list) = make_list(&c->node)))
                                    YYABORT;
                            }
#line 4000 "hlsl.tab.c"
    break;

  case 115:
#line 1991 "hlsl.y"
                            {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                c->node.loc = get_location(&yylloc);
                                c->node.data_type = new_hlsl_type(d3dcompiler_strdup("bool"), HLSL_CLASS_SCALAR, HLSL_TYPE_BOOL, 1, 1);
                                c->v.value.b[0] = (yyvsp[0].boolval);
                                if (!((yyval.list) = make_list(&c->node)))
                                    YYABORT;
                            }
#line 4019 "hlsl.tab.c"
    break;

  case 116:
#line 2006 "hlsl.y"
                            {
                                struct hlsl_ir_deref *deref;
                                struct hlsl_ir_var *var;

                                if (!(var = get_variable(hlsl_ctx.cur_scope, (yyvsp[0].name))))
                                {
                                    hlsl_message("Line %d: variable '%s' not declared\n",
                                            hlsl_ctx.line_no, (yyvsp[0].name));
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                                if ((deref = new_var_deref(var)))
                                {
                                    deref->node.loc = get_location(&(yylsp[0]));
                                    if (!((yyval.list) = make_list(&deref->node)))
                                        YYABORT;
                                }
                                else
                                    (yyval.list) = NULL;
                            }
#line 4044 "hlsl.tab.c"
    break;

  case 117:
#line 2027 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-1].list);
                            }
#line 4052 "hlsl.tab.c"
    break;

  case 118:
#line 2032 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4060 "hlsl.tab.c"
    break;

  case 119:
#line 2036 "hlsl.y"
                            {
                                struct source_location loc;
                                struct hlsl_ir_node *inc;

                                loc = get_location(&(yylsp[0]));
                                if (node_from_list((yyvsp[-1].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                inc = new_unary_expr(HLSL_IR_UNOP_POSTINC, node_from_list((yyvsp[-1].list)), loc);
                                /* Post increment/decrement expressions are considered const */
                                inc->data_type = clone_hlsl_type(inc->data_type);
                                inc->data_type->modifiers |= HLSL_MODIFIER_CONST;
                                (yyval.list) = append_unop((yyvsp[-1].list), inc);
                            }
#line 4081 "hlsl.tab.c"
    break;

  case 120:
#line 2053 "hlsl.y"
                            {
                                struct source_location loc;
                                struct hlsl_ir_node *inc;

                                loc = get_location(&(yylsp[0]));
                                if (node_from_list((yyvsp[-1].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                inc = new_unary_expr(HLSL_IR_UNOP_POSTDEC, node_from_list((yyvsp[-1].list)), loc);
                                /* Post increment/decrement expressions are considered const */
                                inc->data_type = clone_hlsl_type(inc->data_type);
                                inc->data_type->modifiers |= HLSL_MODIFIER_CONST;
                                (yyval.list) = append_unop((yyvsp[-1].list), inc);
                            }
#line 4102 "hlsl.tab.c"
    break;

  case 121:
#line 2070 "hlsl.y"
                            {
                                struct hlsl_ir_node *node = node_from_list((yyvsp[-2].list));
                                struct source_location loc;

                                loc = get_location(&(yylsp[-1]));
                                if (node->data_type->type == HLSL_CLASS_STRUCT)
                                {
                                    struct hlsl_type *type = node->data_type;
                                    struct hlsl_struct_field *field;

                                    (yyval.list) = NULL;
                                    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
                                    {
                                        if (!strcmp((yyvsp[0].name), field->name))
                                        {
                                            struct hlsl_ir_deref *deref = new_record_deref(node, field);

                                            if (!deref)
                                            {
                                                ERR("Out of memory\n");
                                                YYABORT;
                                            }
                                            deref->node.loc = loc;
                                            (yyval.list) = append_unop((yyvsp[-2].list), &deref->node);
                                            break;
                                        }
                                    }
                                    if (!(yyval.list))
                                    {
                                        hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                                                "invalid subscript %s", debugstr_a((yyvsp[0].name)));
                                        YYABORT;
                                    }
                                }
                                else if (node->data_type->type <= HLSL_CLASS_LAST_NUMERIC)
                                {
                                    struct hlsl_ir_swizzle *swizzle;

                                    swizzle = get_swizzle(node, (yyvsp[0].name), &loc);
                                    if (!swizzle)
                                    {
                                        hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                                                "invalid swizzle %s", debugstr_a((yyvsp[0].name)));
                                        YYABORT;
                                    }
                                    (yyval.list) = append_unop((yyvsp[-2].list), &swizzle->node);
                                }
                                else
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                                            "invalid subscript %s", debugstr_a((yyvsp[0].name)));
                                    YYABORT;
                                }
                            }
#line 4161 "hlsl.tab.c"
    break;

  case 122:
#line 2125 "hlsl.y"
                            {
                                /* This may be an array dereference or a vector/matrix
                                 * subcomponent access.
                                 * We store it as an array dereference in any case. */
                                struct hlsl_ir_deref *deref = d3dcompiler_alloc(sizeof(*deref));
                                struct hlsl_type *expr_type = node_from_list((yyvsp[-3].list))->data_type;

                                TRACE("Array dereference from type %s\n", debug_hlsl_type(expr_type));
                                if (!deref)
                                {
                                    ERR("Out of memory\n");
                                    YYABORT;
                                }
                                deref->node.type = HLSL_IR_DEREF;
                                deref->node.loc = get_location(&(yylsp[-2]));
                                if (expr_type->type == HLSL_CLASS_ARRAY)
                                {
                                    deref->node.data_type = expr_type->e.array.type;
                                }
                                else if (expr_type->type == HLSL_CLASS_MATRIX)
                                {
                                    deref->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, expr_type->base_type, expr_type->dimx, 1);
                                }
                                else if (expr_type->type == HLSL_CLASS_VECTOR)
                                {
                                    deref->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_SCALAR, expr_type->base_type, 1, 1);
                                }
                                else
                                {
                                    if (expr_type->type == HLSL_CLASS_SCALAR)
                                        hlsl_report_message(get_location(&(yylsp[-2])), HLSL_LEVEL_ERROR, "array-indexed expression is scalar");
                                    else
                                        hlsl_report_message(get_location(&(yylsp[-2])), HLSL_LEVEL_ERROR, "expression is not array-indexable");
                                    d3dcompiler_free(deref);
                                    free_instr_list((yyvsp[-3].list));
                                    free_instr_list((yyvsp[-1].list));
                                    YYABORT;
                                }
                                if (node_from_list((yyvsp[-1].list))->data_type->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR, "array index is not scalar");
                                    d3dcompiler_free(deref);
                                    free_instr_list((yyvsp[-3].list));
                                    free_instr_list((yyvsp[-1].list));
                                    YYABORT;
                                }
                                deref->src.type = HLSL_IR_DEREF_ARRAY;
                                deref->src.v.array.array = node_from_list((yyvsp[-3].list));
                                deref->src.v.array.index = node_from_list((yyvsp[-1].list));

                                (yyval.list) = append_binop((yyvsp[-3].list), (yyvsp[-1].list), &deref->node);
                            }
#line 4218 "hlsl.tab.c"
    break;

  case 123:
#line 2180 "hlsl.y"
                            {
                                struct hlsl_ir_constructor *constructor;

                                TRACE("%s constructor.\n", debug_hlsl_type((yyvsp[-3].type)));
                                if ((yyvsp[-4].modifiers))
                                {
                                    hlsl_message("Line %u: unexpected modifier in a constructor.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                                if ((yyvsp[-3].type)->type > HLSL_CLASS_LAST_NUMERIC)
                                {
                                    hlsl_message("Line %u: constructors are allowed only for numeric data types.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                                if ((yyvsp[-3].type)->dimx * (yyvsp[-3].type)->dimy != initializer_size(&(yyvsp[-1].initializer)))
                                {
                                    hlsl_message("Line %u: wrong number of components in constructor.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                                assert((yyvsp[-1].initializer).args_count <= ARRAY_SIZE(constructor->args));

                                constructor = d3dcompiler_alloc(sizeof(*constructor));
                                constructor->node.type = HLSL_IR_CONSTRUCTOR;
                                constructor->node.loc = get_location(&(yylsp[-2]));
                                constructor->node.data_type = (yyvsp[-3].type);
                                constructor->args_count = (yyvsp[-1].initializer).args_count;
                                memcpy(constructor->args, (yyvsp[-1].initializer).args, (yyvsp[-1].initializer).args_count * sizeof(*(yyvsp[-1].initializer).args));
                                d3dcompiler_free((yyvsp[-1].initializer).args);
                                (yyval.list) = append_unop((yyvsp[-1].initializer).instrs, &constructor->node);
                            }
#line 4259 "hlsl.tab.c"
    break;

  case 124:
#line 2218 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4267 "hlsl.tab.c"
    break;

  case 125:
#line 2222 "hlsl.y"
                            {
                                struct source_location loc;

                                loc = get_location(&(yylsp[-1]));
                                if (node_from_list((yyvsp[0].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                (yyval.list) = append_unop((yyvsp[0].list), new_unary_expr(HLSL_IR_UNOP_PREINC, node_from_list((yyvsp[0].list)), loc));
                            }
#line 4283 "hlsl.tab.c"
    break;

  case 126:
#line 2234 "hlsl.y"
                            {
                                struct source_location loc;

                                loc = get_location(&(yylsp[-1]));
                                if (node_from_list((yyvsp[0].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                (yyval.list) = append_unop((yyvsp[0].list), new_unary_expr(HLSL_IR_UNOP_PREDEC, node_from_list((yyvsp[0].list)), loc));
                            }
#line 4299 "hlsl.tab.c"
    break;

  case 127:
#line 2246 "hlsl.y"
                            {
                                enum hlsl_ir_expr_op ops[] = {0, HLSL_IR_UNOP_NEG,
                                        HLSL_IR_UNOP_LOGIC_NOT, HLSL_IR_UNOP_BIT_NOT};

                                if ((yyvsp[-1].unary_op) == UNARY_OP_PLUS)
                                {
                                    (yyval.list) = (yyvsp[0].list);
                                }
                                else
                                {
                                    (yyval.list) = append_unop((yyvsp[0].list), new_unary_expr(ops[(yyvsp[-1].unary_op)], node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                                }
                            }
#line 4317 "hlsl.tab.c"
    break;

  case 128:
#line 2261 "hlsl.y"
                            {
                                struct hlsl_type *src_type = node_from_list((yyvsp[0].list))->data_type;
                                struct hlsl_type *dst_type;
                                struct source_location loc;

                                loc = get_location(&(yylsp[-3]));
                                if ((yyvsp[-4].modifiers))
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "unexpected modifier in a cast");
                                    YYABORT;
                                }

                                if ((yyvsp[-2].intval))
                                    dst_type = new_array_type((yyvsp[-3].type), (yyvsp[-2].intval));
                                else
                                    dst_type = (yyvsp[-3].type);

                                if (!compatible_data_types(src_type, dst_type))
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "can't cast from %s to %s",
                                            debug_hlsl_type(src_type), debug_hlsl_type(dst_type));
                                    YYABORT;
                                }

                                (yyval.list) = append_unop((yyvsp[0].list), &new_cast(node_from_list((yyvsp[0].list)), dst_type, &loc)->node);
                            }
#line 4348 "hlsl.tab.c"
    break;

  case 129:
#line 2289 "hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_PLUS;
                            }
#line 4356 "hlsl.tab.c"
    break;

  case 130:
#line 2293 "hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_MINUS;
                            }
#line 4364 "hlsl.tab.c"
    break;

  case 131:
#line 2297 "hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_LOGICNOT;
                            }
#line 4372 "hlsl.tab.c"
    break;

  case 132:
#line 2301 "hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_BITNOT;
                            }
#line 4380 "hlsl.tab.c"
    break;

  case 133:
#line 2306 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4388 "hlsl.tab.c"
    break;

  case 134:
#line 2310 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_MUL,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4397 "hlsl.tab.c"
    break;

  case 135:
#line 2315 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_DIV,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4406 "hlsl.tab.c"
    break;

  case 136:
#line 2320 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_MOD,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4415 "hlsl.tab.c"
    break;

  case 137:
#line 2326 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4423 "hlsl.tab.c"
    break;

  case 138:
#line 2330 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_ADD,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4432 "hlsl.tab.c"
    break;

  case 139:
#line 2335 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_SUB,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4441 "hlsl.tab.c"
    break;

  case 140:
#line 2341 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4449 "hlsl.tab.c"
    break;

  case 141:
#line 2345 "hlsl.y"
                            {
                                FIXME("Left shift\n");
                            }
#line 4457 "hlsl.tab.c"
    break;

  case 142:
#line 2349 "hlsl.y"
                            {
                                FIXME("Right shift\n");
                            }
#line 4465 "hlsl.tab.c"
    break;

  case 143:
#line 2354 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4473 "hlsl.tab.c"
    break;

  case 144:
#line 2358 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_LESS,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4482 "hlsl.tab.c"
    break;

  case 145:
#line 2363 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_GREATER,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4491 "hlsl.tab.c"
    break;

  case 146:
#line 2368 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_LEQUAL,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4500 "hlsl.tab.c"
    break;

  case 147:
#line 2373 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_GEQUAL,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4509 "hlsl.tab.c"
    break;

  case 148:
#line 2379 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4517 "hlsl.tab.c"
    break;

  case 149:
#line 2383 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_EQUAL,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4526 "hlsl.tab.c"
    break;

  case 150:
#line 2388 "hlsl.y"
                            {
                                (yyval.list) = append_binop((yyvsp[-2].list), (yyvsp[0].list), new_binary_expr(HLSL_IR_BINOP_NEQUAL,
                                        node_from_list((yyvsp[-2].list)), node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                            }
#line 4535 "hlsl.tab.c"
    break;

  case 151:
#line 2394 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4543 "hlsl.tab.c"
    break;

  case 152:
#line 2398 "hlsl.y"
                            {
                                FIXME("bitwise AND\n");
                            }
#line 4551 "hlsl.tab.c"
    break;

  case 153:
#line 2403 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4559 "hlsl.tab.c"
    break;

  case 154:
#line 2407 "hlsl.y"
                            {
                                FIXME("bitwise XOR\n");
                            }
#line 4567 "hlsl.tab.c"
    break;

  case 155:
#line 2412 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4575 "hlsl.tab.c"
    break;

  case 156:
#line 2416 "hlsl.y"
                            {
                                FIXME("bitwise OR\n");
                            }
#line 4583 "hlsl.tab.c"
    break;

  case 157:
#line 2421 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4591 "hlsl.tab.c"
    break;

  case 158:
#line 2425 "hlsl.y"
                            {
                                FIXME("logic AND\n");
                            }
#line 4599 "hlsl.tab.c"
    break;

  case 159:
#line 2430 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4607 "hlsl.tab.c"
    break;

  case 160:
#line 2434 "hlsl.y"
                            {
                                FIXME("logic OR\n");
                            }
#line 4615 "hlsl.tab.c"
    break;

  case 161:
#line 2439 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4623 "hlsl.tab.c"
    break;

  case 162:
#line 2443 "hlsl.y"
                            {
                                FIXME("ternary operator\n");
                            }
#line 4631 "hlsl.tab.c"
    break;

  case 163:
#line 2448 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4639 "hlsl.tab.c"
    break;

  case 164:
#line 2452 "hlsl.y"
                            {
                                struct hlsl_ir_node *instr;

                                if (node_from_list((yyvsp[-2].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR, "l-value is const");
                                    YYABORT;
                                }
                                if (!(instr = make_assignment(node_from_list((yyvsp[-2].list)), (yyvsp[-1].assign_op), node_from_list((yyvsp[0].list)))))
                                    YYABORT;
                                instr->loc = get_location(&(yylsp[-1]));
                                (yyval.list) = append_binop((yyvsp[0].list), (yyvsp[-2].list), instr);
                            }
#line 4657 "hlsl.tab.c"
    break;

  case 165:
#line 2467 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_ASSIGN;
                            }
#line 4665 "hlsl.tab.c"
    break;

  case 166:
#line 2471 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_ADD;
                            }
#line 4673 "hlsl.tab.c"
    break;

  case 167:
#line 2475 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_SUB;
                            }
#line 4681 "hlsl.tab.c"
    break;

  case 168:
#line 2479 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_MUL;
                            }
#line 4689 "hlsl.tab.c"
    break;

  case 169:
#line 2483 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_DIV;
                            }
#line 4697 "hlsl.tab.c"
    break;

  case 170:
#line 2487 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_MOD;
                            }
#line 4705 "hlsl.tab.c"
    break;

  case 171:
#line 2491 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_LSHIFT;
                            }
#line 4713 "hlsl.tab.c"
    break;

  case 172:
#line 2495 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_RSHIFT;
                            }
#line 4721 "hlsl.tab.c"
    break;

  case 173:
#line 2499 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_AND;
                            }
#line 4729 "hlsl.tab.c"
    break;

  case 174:
#line 2503 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_OR;
                            }
#line 4737 "hlsl.tab.c"
    break;

  case 175:
#line 2507 "hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_XOR;
                            }
#line 4745 "hlsl.tab.c"
    break;

  case 176:
#line 2512 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4753 "hlsl.tab.c"
    break;

  case 177:
#line 2516 "hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                list_move_tail((yyval.list), (yyvsp[0].list));
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 4763 "hlsl.tab.c"
    break;


#line 4767 "hlsl.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2522 "hlsl.y"


static struct source_location get_location(const struct YYLTYPE *l)
{
    const struct source_location loc =
    {
        .file = hlsl_ctx.source_file,
        .line = l->first_line,
        .col = l->first_column,
    };
    return loc;
}

static void dump_function_decl(struct wine_rb_entry *entry, void *context)
{
    struct hlsl_ir_function_decl *func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function_decl, entry);
    if (func->body)
        debug_dump_ir_function_decl(func);
}

static void dump_function(struct wine_rb_entry *entry, void *context)
{
    struct hlsl_ir_function *func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);
    wine_rb_for_each_entry(&func->overloads, dump_function_decl, NULL);
}

struct bwriter_shader *parse_hlsl(enum shader_type type, DWORD major, DWORD minor,
        const char *entrypoint, char **messages)
{
    struct hlsl_scope *scope, *next_scope;
    struct hlsl_type *hlsl_type, *next_type;
    struct hlsl_ir_var *var, *next_var;
    unsigned int i;

    hlsl_ctx.status = PARSE_SUCCESS;
    hlsl_ctx.messages.size = hlsl_ctx.messages.capacity = 0;
    hlsl_ctx.line_no = hlsl_ctx.column = 1;
    hlsl_ctx.source_file = d3dcompiler_strdup("");
    hlsl_ctx.source_files = d3dcompiler_alloc(sizeof(*hlsl_ctx.source_files));
    if (hlsl_ctx.source_files)
        hlsl_ctx.source_files[0] = hlsl_ctx.source_file;
    hlsl_ctx.source_files_count = 1;
    hlsl_ctx.cur_scope = NULL;
    hlsl_ctx.matrix_majority = HLSL_COLUMN_MAJOR;
    list_init(&hlsl_ctx.scopes);
    list_init(&hlsl_ctx.types);
    init_functions_tree(&hlsl_ctx.functions);

    push_scope(&hlsl_ctx);
    hlsl_ctx.globals = hlsl_ctx.cur_scope;
    declare_predefined_types(hlsl_ctx.globals);

    hlsl_parse();

    if (TRACE_ON(hlsl_parser))
    {
        TRACE("IR dump.\n");
        wine_rb_for_each_entry(&hlsl_ctx.functions, dump_function, NULL);
    }

    TRACE("Compilation status = %d\n", hlsl_ctx.status);
    if (messages)
    {
        if (hlsl_ctx.messages.size)
            *messages = hlsl_ctx.messages.string;
        else
            *messages = NULL;
    }
    else
    {
        if (hlsl_ctx.messages.capacity)
            d3dcompiler_free(hlsl_ctx.messages.string);
    }

    for (i = 0; i < hlsl_ctx.source_files_count; ++i)
        d3dcompiler_free((void *)hlsl_ctx.source_files[i]);
    d3dcompiler_free(hlsl_ctx.source_files);

    TRACE("Freeing functions IR.\n");
    wine_rb_destroy(&hlsl_ctx.functions, free_function_rb, NULL);

    TRACE("Freeing variables.\n");
    LIST_FOR_EACH_ENTRY_SAFE(scope, next_scope, &hlsl_ctx.scopes, struct hlsl_scope, entry)
    {
        LIST_FOR_EACH_ENTRY_SAFE(var, next_var, &scope->vars, struct hlsl_ir_var, scope_entry)
        {
            free_declaration(var);
        }
        wine_rb_destroy(&scope->types, NULL, NULL);
        d3dcompiler_free(scope);
    }

    TRACE("Freeing types.\n");
    LIST_FOR_EACH_ENTRY_SAFE(hlsl_type, next_type, &hlsl_ctx.types, struct hlsl_type, entry)
    {
        free_hlsl_type(hlsl_type);
    }

    return NULL;
}
